var ZConfluenceMapper = function($rootScope, $scope, $q, cMapperRemoteService) {
    var zd = this;
    zd.selectedLabel = '';
    zd.labels = [];
    zd.rows = [];

    zd.rowCounter = 0;

    zd.waitingForCategories = false;
    zd.waitingForLabels = false;
    zd.success = false;
    zd.error = false;

    zd.errorMessage;

    zd.$onInit = function() {
        if(globalTarget!='ZENDESK'){
            return;
        }
        $rootScope["zmapper"] = {};
        $rootScope["zmapper"].controller = zd;
        if (zd.savebutton == "true") {
            zd.showSaveButton = true;
        } else {
            zd.showSaveButton = false;
        }
        zd.confluenceLabels();
        zd.loadMap();
    };

    zd.confluenceLabels = function() {
        zd.waitingForLabels = true;
        cMapperRemoteService.confluenceLabels(zd.space).then(function(result) {
            zd.labels = result['labels'];
            zd.waitingForLabels = false;
        }).catch(function(response) {
            window.console.log('mapper meta error', response);
            zd.error = true;
            if (response.data && response.data.message) {
                zd.errorMessage  = response.data.message;
            }else if(response.statusText){
                zd.errorMessage  = response.statusText;
            }else{
                zd.errorMessage  = 'Unknown Error';
            }
        }).finally(function() {});
    }

    zd.addRow = function() {
        if (zd.selectedLabel != null) {
            if (zd.selectedLabel.name != null && zd.selectedLabel.name != "") {
                zd.waitingForCategories = true;
                cMapperRemoteService.getCategories().then(function(result) {
                    zd.rows.push({
                        "label": zd.selectedLabel,
                        "id": "row_" + zd.rowCounter,
                        "categories": result
                    });
                    zd.rowCounter = zd.rowCounter + 1;
                }).catch(function(response) {
                    zd.error = true;
                    if (response.data && response.data.message) {
                        zd.errorMessage = response.data.message;
                    }else if(response.statusText){
                        zd.errorMessage = response.statusText;
                    }else{
                        zd.errorMessage = 'Unknown Error';
                    }
                }).finally(function() {
                    zd.selectedLabel = null;
                    zd.waitingForCategories = false;
                })
            }
        }
    }

    zd.loadRow = function(selectedLabel, categoryId, sectionId) {
        if (selectedLabel != null) {
            if (selectedLabel.name != null && selectedLabel.name != "") {
                zd.waitingForCategories = true;
                cMapperRemoteService.getCategories().then(function(result) {
                    zd.rows.push({
                        "label": selectedLabel,
                        "id": "row_" + zd.rowCounter,
                        "categories": result
                    });

                    var categories = zd.rows[zd.rowCounter].categories;

                    var indexCategoryId = categories.map(function(e) {
                        return e.id.toString();
                    }).indexOf(categoryId);

                    zd.rows[zd.rowCounter].category = zd.rows[zd.rowCounter].categories[indexCategoryId];

                    zd.loadSection(zd.rowCounter, categoryId, sectionId);

                    zd.rowCounter = zd.rowCounter + 1;
                }).catch(function(response) {
                    zd.error = true;
                    if(response.data && response.data.message){
                        zd.errorMessage = response.data.message;
                    }else if(response.statusText){
                        zd.errorMessage = response.statusText;
                    }else{
                        zd.errorMessage = 'Unknown Error';
                    }

                }).finally(function() {
                    zd.waitingForCategories = false;
                })
            }
        }
    }

    zd.disableLabelOption = function(labelId) {
        var result = false;
        window.zkbangular.forEach(zd.rows, function (row) {
            if (row.label != null && row.label.id == labelId) {
                result = true;
            }
        });
        return result;
    }

    zd.addSection = function(rowId, categoryId) {
        var index = zd.rows.map(function(e) {
            return e.id;
        }).indexOf(rowId);
        cMapperRemoteService.getSections(categoryId).then(function(result) {
            zd.rows[index]["sections"] = result["lstSections"];
        }).catch(function(response) {
            zd.rows[index]["sections"] = null;
            zd.error = true;
            if (response.data && response.data.message) {
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage = response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
        }).finally(function() {});
    }

    zd.loadSection = function(rowIndex, categoryId, sectionId) {
        cMapperRemoteService.getSections(categoryId).then(function(result) {
            zd.rows[rowIndex]["sections"] = result["lstSections"];

            var sections = result["lstSections"];

            var indexSectionId = sections.map(function(e) {
                return e.id.toString();
            }).indexOf(sectionId);

            zd.rows[rowIndex].section = zd.rows[rowIndex].sections[indexSectionId];

        }).catch(function(response) {
            zd.rows[index]["sections"] = null;
            zd.error = true;
            if (response.data && response.data.message) {
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage = response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
        }).finally(function() {});
    }

    zd.deleteRow = function(event) {
        var rowId = window.zkbangular.element(event.target.parentNode.parentNode).attr("id");
        var index = zd.rows.map(function (e) {
            return e.id;
        }).indexOf(rowId);
        zd.rows.splice(index, 1);
        zd.disabled()
    }

    zd.clear = function() {
        zd.rows = [];
    }

    zd.saveMap = function() {
        var deferred = $q.defer();
        var labelMapping = [];
        var noneSelected = true;
        window.zkbangular.forEach(zd.rows, function (row) {
            if (row.label != null && row.category != null && row.section != null) {
                labelMapping.push({
                    "label": row.label.name,
                    "categoryId": row.category.id.toString(),
                    "sectionId": row.section.id.toString()
                });
                noneSelected = false;
            }
        });
        cMapperRemoteService.saveMap(zd.space, labelMapping).then(function(result) {
            zd.success = true;
            zd.labels = [];
            zd.error = false;
            zd.errorMessage = null;
            deferred.resolve(zd.success);
        }).catch(function(response) {
            zd.error = true;
            if (response.data && response.data.message) {
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage = response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
            deferred.reject(zd.success);
        }).finally(function() {});
        return deferred.promise;
    }

    zd.loadMap = function() {
        cMapperRemoteService.loadMapper(zd.space).then(function(result) {
            window.zkbangular.forEach(result.labelMap, function (map) {
                var label = map.label;
                var categoryId = map.categoryId;
                var sectionId = map.sectionId;
                var indexLabel = zd.labels.map(function (e) {
                    return e.name;
                }).indexOf(label);
                zd.loadRow(zd.labels[indexLabel], categoryId, sectionId);

            });
        }).catch(function(response) {
            zd.error = true;
            if (response.data && response.data.message) {
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage = response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
        }).finally(function() {

        });
    }

};

var cMapperRemoteService = function($rootScope, $q, $http) {
    return {
        confluenceLabels: function(space) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/wizard/confluence-labels/" + space,
                headers: {
                    'Content-Type': "application/json"
                },
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getSections: function(categoryId) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/zendesk-utils/sections/" + categoryId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getCategories: function() {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/zendesk-utils/categories",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        saveMap: function(space, labelMapping) {
            var deferred = $q.defer();
            var req = {
                method: "POST",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/wizard/save-mapping/" + space,
                headers: {
                    'Content-Type': "application/json"
                },
                data: {
                    "labelMap": labelMapping
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        loadMapper: function(spaceKey) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/bulk/mapper/ZENDESK?spaceKey=" + spaceKey,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                var result = response.data;
                deferred.resolve(result);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        remoteSaveMap: function() {
            var deferred = $q.defer();
            $rootScope["zmapper"].controller.saveMap().then(function(result) {
                deferred.resolve(result);
            }).catch(function(response) {
                deferred.reject(response);
            }).finally(function() {})
            return deferred.promise;
        }
    };
};

var zAppMapper = zApp;
zAppMapper.factory("cMapperRemoteService", cMapperRemoteService);
cMapperRemoteService.$inject = ["$rootScope", "$q", "$http"];

zAppMapper.component("zmapper", {
    bindings: {
        space: '@',
        savebutton: '@'
    },
    templateUrl: AJS.Data.get("context-path") +
        '/download/resources/com.zagile.confluence.kb.knowledge-bridge:angular-templates/confluence-page-mapper.html',
    controller: ['$rootScope', '$scope', '$q', 'cMapperRemoteService', ZConfluenceMapper],
});