AJS.toInit(function () {
    AJS.$('#zSFHistoryDialogWebItem').click(function (e) {
        e.preventDefault();
        if (AJS.$("#zHistoryDialog").length === 0) {
            initHistoryDialog("SALESFORCE");
        } else {
            AJS.dialog2("#zHistoryDialog").show();
        }
    });
    AJS.$('#zHistoryDialogWebItem').click(function (e) {
        e.preventDefault();
        if (AJS.$("#zHistoryDialog").length === 0) {
            initHistoryDialog("ZENDESK");
        } else {
            AJS.dialog2("#zHistoryDialog").show();
        }
    });
});
var HistoryController = function ($scope, historyService, ztarget) {
    var zd = this;
    zd.maxEntries = 5;
    zd.entriesWithoutErrors = 0;
    zd.isShowing = {
        loader: true,
        history: false
    };

    AJS.dialog2("#zHistoryDialog").show();
    var target = ztarget;
    historyService.getHistory(target).then(function (result) {
        window.console.log('getHistory', result);
        zd.historyList = result;
        for (var i = 0; i < zd.historyList.length; i++) {
            zd.historyList[i].urlUser = AJS.contextPath() + "/display/~" + zd.historyList[i].user;

            if(!zd.historyList[i].error){
                zd.historyList[i].literalEntry = zd.buildLiteralEntry(zd.historyList[i]);
                zd.entriesWithoutErrors += 1;
            }
            //TODO Build literal entry for errors
            zd.historyList[i].showMetadata = zd.showMetadata(zd.historyList[i]);
            zd.historyList[i].literalEnding = zd.buildLiteralEnding(zd.historyList[i]);
            zd.historyList[i].hasVersion = zd.hasVersion(zd.historyList[i]);
            zd.historyList[i].hasVersionID = zd.hasVersionID(zd.historyList[i]);
            zd.historyList[i].urlVersion = "viewpage.action?pageId="+zd.historyList[i].versionPageId;
        }
        zd.isShowing.history = true;
    }).catch(function (response) {
        window.console.log('getHistory error', response);
        zd.error = true;

        if (response.data && response.data.message) {
            zd.errorMessage = response.data.message;
        }else if(response.statusText){
            zd.errorMessage = response.statusText;
        }else{
            zd.errorMessage = 'Unknown Error';
        }
    }).finally(function () {
        zd.isShowing.loader = false;
    });
    //--
    zd.formatDate = function (longDate) {
        var date = new Date(longDate);
        return date.toLocaleString();
    };
    zd.hasVersionID = function (zHistoryUserEntry) {
        return zHistoryUserEntry.versionPageId != null;
    };

    zd.closeDialog = function () {
        AJS.dialog2("#zHistoryDialog").hide();
    };
    zd.showMetadata = function (zHistoryUserEntry) {
        var flag = false;
        if (zHistoryUserEntry.action === "UPDATE_METADATA") {
            flag = true;
        }
        return flag;
    };
    zd.hasVersion = function (zHistoryUserEntry) {
        var flag = false;
        if (zHistoryUserEntry.action === "PUBLISH" || zHistoryUserEntry.action === "UPDATE") {
            flag = true;
        }
        return flag;
    };
    zd.buildLiteralEntry = function (zHistoryUserEntry) {
        var literal = " ";
        var date = zHistoryUserEntry.actionDate;
        if (zHistoryUserEntry.action === "PUBLISH") {
            literal += " published Page ";
        } else if (zHistoryUserEntry.action === "UPDATE") {
            literal += " updated to Salesforce, Page ";
        } else if (zHistoryUserEntry.action === "MAKE_PUBLIC") {
            literal += " made the article public";
            literal += " - " + date;
        } else if (zHistoryUserEntry.action === "UPDATE_METADATA") {
            literal += " updated the article metadata";
            literal += " - " + date;
        }else if (zHistoryUserEntry.action === "UNPUBLISH") {
            literal += " unpublished and deleted the article";
        }else if (zHistoryUserEntry.action === "FORCE_DELETE") {
            literal += " deleted in Confluence";
        }
        return literal;
    };

    zd.buildLiteralEnding = function (zHistoryUserEntry) {
        var literal = "";
        var date = zHistoryUserEntry.actionDate;
        if (zHistoryUserEntry.action === "PUBLISH") {
            if (zHistoryUserEntry.translations[0].draft) {
                literal += " as draft";
            }
            literal += " - " + date;
        } else if (zHistoryUserEntry.action === "UPDATE") {
            if (zHistoryUserEntry.translations[0].draft) {
                literal += " as draft";
            }
            literal += " - " + date;
        }else if (zHistoryUserEntry.action === "UNPUBLISH" || zHistoryUserEntry.action === "FORCE_DELETE") {
            literal += " - " + date;
        }
        return literal;
    }
};
var historyService = function ($q, $http) {
    return {
        getHistory: function (ztarget) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/history/get-history/" +
                    AJS.params.pageId + "/" + ztarget,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        }
    };
};

function initHistoryDialog(target) {
    //--inject dialog with angular component to body
    var dialog2Str = '';
    dialog2Str += '<section role="dialog" id="zHistoryDialog" class="aui-layer aui-dialog2 aui-dialog2-medium" aria-hidden="true">';
    dialog2Str += '<div ng-app="history-src">';
    dialog2Str += '<zhistory>';
    dialog2Str += '</zhistory>';
    dialog2Str += '</div>';
    dialog2Str += '</section>';
    AJS.$(document.body).append(AJS.$(dialog2Str));

    //--create angular app, initiate component and relate controller and services
    var zHistory = window.zkbangular.module("history-src", []);

    var zpage = "";
    if (target === "SALESFORCE") {
        zHistory.value('ztarget', "SALESFORCE");
        zpage = 'salesforce-history.html';
    } else {
        zHistory.value('ztarget', "ZENDESK");
        zpage = 'history.html';
    }

    zHistory.factory("historyService", historyService);
    historyService.$inject = ["$q", "$http"];

    zHistory.component("zhistory", {
        templateUrl: AJS.Data.get("context-path") +
            '/download/resources/com.zagile.confluence.kb.knowledge-bridge:angular-templates/' + zpage,
        controller: ['$scope', 'historyService', 'ztarget', HistoryController]
    });

    //--compile angular app
    var injector = window.zkbangular.injector(["ng", "history-src"]);
    injector.invoke(function ($compile, $rootScope) {
        $compile(AJS.$("div[ng-app='history-src']"))($rootScope);
        $rootScope.$apply();
    });
}