
var SConfluenceTree=function($rootScope,$scope,cTreeRemoteService,KCSService,KFService){
    var sf = this;

    sf.target = "SALESFORCE";
    sf.modal = {};

    sf.treeLoader=false;
    sf.showWait = false;
    sf.error = false;
    sf.success  = false;
    sf.modal.dialogInitiated = false;
    sf.contextPath=AJS.contextPath();
    sf.waitIconUrl = AJS.contextPath()+'/images/icons/wait.gif';


    sf.$onInit=function(){
        $rootScope["stree"]={};
        $rootScope["stree"].spaceArticles = {};
        $rootScope["stree"].controller = sf;

        sf.renderTree();
    };

    sf.channelLabel=function(channel){
        return KFService.channelLabel(channel);
    };

    sf.reRender=function(mode){
        sf.mode = mode;
        sf.renderTree();
    };
    sf.refresh=function(){
        sf.renderTree();
    };
    sf.renderTree=function(){
        if(sf.mode==""){
            return;
        }
        jzq('#stree').jstree("destroy").empty();
        jzq('.aui-inline-dialog').remove();
        $rootScope["stree"].spaceArticles = {};
        sf.treeLoader=true;
        cTreeRemoteService.renderTree(sf.space,sf.mode,sf.target).then(function(result){
            window.console.log('tree meta',result);
            sf.fillRootAndTree(result);
        }).catch(function(response){
            window.console.log('tree meta error',response);
            sf.error = true;
            if(response.data && response.data.message){
                sf.errorMessage = response.data.message;
            }else if(response.statusText){
                sf.errorMessage = response.statusText;
            }else{
                sf.errorMessage = 'Unknown Error';
            }
        }).finally(function(){
            sf.treeLoader=false;
        });
    };


    sf.showInfo=function(pageId) {
        var pageIdStr =  pageId+'';
        sf.spage = $rootScope["stree"].spaceArticles[pageIdStr];

        if(sf.spage.zPageNodeInfo.published && !sf.spage.zPageNodeInfo.translations) {
            sf.spage.zPageNodeInfo.translationsLoader = true;
            sf.spage.zPageNodeInfo.translationsError = false;
            cTreeRemoteService.editMeta(pageId).then(function(result){
                window.console.log('edit meta',result);
                sf.spage.zPageNodeInfo.translations = result.translations;

                if(sf.spage.zPageNodeInfo.length==0){
                    sf.spage.zPageNodeInfo.translationsError = true;
                    sf.spage.zPageNodeInfo.errorMessage = "Error, no publications found";
                }else{
                    sf.spage.zPageNodeInfo.translations.forEach(function(translation){
                        sf.calculateKAVsToShow(translation);
                    });
                }
            }).catch(function(response){
                window.console.log('edit meta error',response);

                sf.spage.zPageNodeInfo.translationsError = true;
                if(response.data && response.data.message){
                    sf.spage.zPageNodeInfo.translationsErrorMsg = response.data.message;
                }else if(response.statusText){
                    sf.spage.zPageNodeInfo.translationsErrorMsg = response.statusText;
                }else{
                    sf.spage.zPageNodeInfo.translationsErrorMsg = 'Unknown Error';
                }
            }).finally(function(){
                sf.spage.zPageNodeInfo.translationsLoader = false;

                setTimeout(function(){
                    if(AJS.$('#selectedPage').find('tr[translationsSection]').length>0){
                        var html = AJS.$('#selectedPage').find('tr[translationsSection]').html();
                        AJS.$('#inline-dialog-'+pageId).find('tr[translationsSection]').html(html);
                    }
                },500);
            });
        }

        $rootScope.$apply();
    };
    sf.calculateKAVsToShow = function(translation){
        var kav = translation.knowledgeArticleVersionId;
        var draftKav = translation.draftKnowledgeArticleVersionId;
        var onlineKav = translation.onlineKnowledgeArticleVersionId;

        translation.resultPageShowStoredKAV = kav && true;
        if(!kav || ( kav !== draftKav && kav !== onlineKav )){
            translation.resultPageShowDrafKAV = draftKav && true;
            translation.resultPageShowOnlineKAV = onlineKav && true;
        }
    };
    sf.inlineDialog=function(pageId){
        var popUp = AJS.$("#link_"+pageId).attr('popup');
        if(popUp && popUp=='true'){
            return;
        }
        AJS.$("#link_"+pageId).attr('popup','true');

        AJS.InlineDialog(AJS.$("#link_"+pageId), pageId,
            function(content, trigger, showPopup) {
                var pageIdLink = AJS.$(trigger).attr('pageId');
                sf.showInfo(pageIdLink);
                content.css({"padding":"20px"}).html(AJS.$("#selectedPage").html());
                showPopup();
                return false;
            }
        );
    };
    sf.calcMeta=function(){
        if(!sf.spage){
            return;
        }

        if(sf.mode=='descendants' && !sf.spage.zPageNodeInfo.metadata){
            var tmpNode = sf.spage.parent;
            while (tmpNode) {
                if (tmpNode.zPageNodeInfo.metadata) {
                    return {
                        title:'Inherited Metadata',
                        metadata:tmpNode.zPageNodeInfo.metadata,
                        display:true
                    };
                }
                tmpNode = tmpNode.parent;
            }
        }
        return {
            title:'Metadata',
            metadata:sf.spage.zPageNodeInfo.metadata,
            display:sf.spage.zPageNodeInfo.metadata && !sf.spage.zPageNodeInfo.published
        };
    };

    sf.nodeMenu=function(node) {
        var items = {
            'item1': {
                'label': 'Select Children',
                'action': function() {
                    jzq("#stree").jstree().select_node(node.id);
                    for(var i = 0;i<node.children.length;i++){
                        if(!jzq("#stree").jstree().get_node(node.children[i]).state.checkbox_disabled) {
                            jzq("#stree").jstree().select_node(node.children[i]);
                        }
                    }
                }
            },
            'item2': {
                'label': 'Select Descendants',
                'action': function() {
                    var tree = jzq("#stree").jstree();
                    tree.select_node(node.id);
                    for(var i = 0;i<node.children_d.length;i++){
                        if(!tree.get_node(node.children_d[i]).state.checkbox_disabled) {
                            tree.select_node(node.children_d[i]);
                        }
                    }
                }
            },
            'item3': {
                'label': 'Unselect Children',
                'action': function () {
                    jzq("#stree").jstree().deselect_node(node.id);
                    for(var i = 0;i<node.children.length;i++){
                        jzq("#stree").jstree().deselect_node(node.children[i]);
                    }
                }
            },
            'item4': {
                'label': 'Unselect Descendants',
                'action': function () {
                    jzq("#stree").jstree().deselect_node(node.id);
                    for(var i = 0;i<node.children_d.length;i++){
                        jzq("#stree").jstree().deselect_node(node.children_d[i]);
                    }
                }
            }
        }
        if (node.type != 'parent') {
            delete items.item1;
            delete items.item2;
            delete items.item3;
            delete items.item4;
        }

        return items;
    };
    sf.fillTree = function(pageParent,nodeParent,level){
        level++;
        for(var i = 0;i<pageParent.childs.length;i++){
            if(pageParent.childs[i].childs.length==0 && pageParent.childs[i].zPageNodeInfo.published){
                continue;
            }

            var nodeChild = {};

            nodeChild.id = pageParent.childs[i].pageId;
            if(pageParent.childs[i].childs.length>0){
                nodeChild.type= "parent";
            }else{
                nodeChild.type= "leaf";
            }
            $rootScope["stree"].spaceArticles[pageParent.childs[i].pageId] = pageParent.childs[i];
            $rootScope["stree"].spaceArticles[pageParent.childs[i].pageId].level = level;
            $rootScope["stree"].spaceArticles[pageParent.childs[i].pageId].parent = pageParent;

            nodeChild.state = {};
            nodeChild.children = [];
            nodeChild.state.opened=false;
            nodeChild.state.checkbox_disabled = pageParent.childs[i].zPageNodeInfo.published;

            nodeChild.text = sf.buildText[sf.mode](pageParent.childs[i]);

            nodeChild.icon = "jstree-file";
            nodeParent.children.push(nodeChild);

            sf.fillTree(pageParent.childs[i],nodeChild,level);
        }
    };

    sf.buildText ={
        free : function (pageNode) {
            var color = 'Gray';
            if (!pageNode.zPageNodeInfo.published && pageNode.zPageNodeInfo.metadata) {
                color = 'SteelBlue';
            }
            return '<a href="#" style="color: '+color+';" id="link_' + pageNode.pageId + '" pageId="' + pageNode.pageId + '">' +
                pageNode.pageTitle + '</a>';

        },
        descendants : function (pageNode) {
            var getColor = function (node) {
                if (node.zPageNodeInfo.published) {
                    return 'Gray';
                } else if (node.zPageNodeInfo.metadata) {
                    return 'SteelBlue';
                }
                var tmpNode = node.parent;

                while (tmpNode) {
                    if (tmpNode.zPageNodeInfo.metadata) {
                        return 'SteelBlue';
                    }
                    tmpNode = tmpNode.parent;
                }
                return 'Black';
            };
            return '<a style="color: '+getColor(pageNode)+'" href="#" id="link_' + pageNode.pageId + '" pageId="' + pageNode.pageId + '">' +
                pageNode.pageTitle + '</a>';

        }
    };
    sf.fillRootAndTree=function(spaceTree){
        var jstree = {};
        jstree.core = {};
        jstree.core.data = [];

        jstree.plugins = [];
        jstree.plugins.push("types");
        jstree.plugins.push("contextmenu");

        jstree.types = {};
        jstree.types.parent={};
        jstree.types.leaf={};

        jstree.contextmenu = {};
        jstree.contextmenu.select_node = false;

        jstree.contextmenu.items = sf.nodeMenu;

        jstree.plugins.push("checkbox");

        jzq.jstree.defaults.checkbox.keep_selected_style = true;
        jzq.jstree.defaults.checkbox.whole_node = true;
        jzq.jstree.defaults.checkbox.three_state = false;
        jzq.jstree.defaults.checkbox.cascade = "";

        var level = 1;
        for(var i = 0;i<spaceTree.root.childs.length;i++){
            if(spaceTree.root.childs[i].childs.length==0 && spaceTree.root.childs[i].zPageNodeInfo.published){
                continue;
            }

            var nodeChild = {};
            nodeChild.id = spaceTree.root.childs[i].pageId;
            if(spaceTree.root.childs[i].childs.length>0){
                nodeChild.type= "parent";
            }else{
                nodeChild.type= "leaf";
            }
            $rootScope["stree"].spaceArticles[spaceTree.root.childs[i].pageId] = spaceTree.root.childs[i];
            $rootScope["stree"].spaceArticles[spaceTree.root.childs[i].pageId].level = level;
            $rootScope["stree"].spaceArticles[spaceTree.root.childs[i].pageId].parent = null;
            nodeChild.state = {};
            nodeChild.state.opened=true;
            nodeChild.state.checkbox_disabled = spaceTree.root.childs[i].zPageNodeInfo.published;

            nodeChild.text = sf.buildText[sf.mode](spaceTree.root.childs[i]);

            nodeChild.children = [];
            nodeChild.icon = "jstree-file";
            jstree.core.data.push(nodeChild);

            sf.fillTree(spaceTree.root.childs[i],nodeChild,level);
        }


        jzq('#stree').bind("ready.jstree", function () {
            for(pageId in $rootScope["stree"].spaceArticles){
                sf.inlineDialog(pageId);
            }
        });

        jzq('#stree').bind("open_node.jstree", function (e,data) {
            for(var i = 0;i<data.node.children_d.length;i++){
                var pageId = data.node.children_d[i];
                sf.inlineDialog(pageId);
            }
        });

        jzq("#stree").jstree(jstree);
    };
    sf.clear = function(){
        cTreeRemoteService.clearAllSelection();
    };
    sf.modal.initDialog= function(selectedNodes){
        sf.modal.showError = false;
        sf.modal.showWarning = false;
        sf.modal.showloader = true;
        sf.modal.dialogInitiated = true;
        sf.modal.showMainForm = false;
        sf.modal.showWait = false;
        sf.modal.updateButtonDisabled = true;

        sf.loadSalesforceMetadata(sf.modal,selectedNodes);

    };
    sf.validateNodeSelections=function(modal,selectedNodes){
        modal.showWarning = false;
        if(selectedNodes!=null){
            for(var i = 0;i<selectedNodes.length;i++){
                if(selectedNodes[i].zPageNodeInfo.published){
                    modal.showWarning = true;
                    modal.warningMessage = "For published pages, Salesforce metadata will be updated only on confluence metadata.";
                    break;
                }
            }
        }
    };

    sf.loadSalesforceMetadata=function(modal,selectedNodes){

        modal.recordTypeError = false;
        modal.showStep2 = false;
        cTreeRemoteService.salesforceCreateMeta(sf.space).then(function(result) {
            window.console.log('create meta', result);
            KFService.setMetadata(result);

            modal.data = result;
            if(modal.data.categories == null || modal.data.categories.length == 0){
                modal.showStep2 = true;
            }else{
                KCSService.setCategoriesMetadata(result);
            }
            modal.showMainForm = true;
            modal.updateButtonDisabled = false;
            if(modal.data.warning){
                modal.showWarning = true;
                modal.warningMessage = modal.data.warningMessage;
            }

        }).catch(function(response) {
            modal.showError = true;
            modal.showWarning = false;

            if(response.data && response.data.message){
                model.errorMessage = response.data.message;
            }else if(response.statusText){
                model.errorMessage = response.statusText;
            }else{
                model.errorMessage = 'Unknown Error';
            }
        }).finally(function() {
            modal.showloader = false;
        });

    };
    sf.selectAll=function(){
        var v =jzq("#stree").jstree(true).get_json('#', {'flat': true});
        for (i = 0; i < v.length ;i++) {
            var z = v[i];
            if(!z.state.checkbox_disabled) {
                jzq("#stree").jstree("select_node", "#" + z.id);
            }
        }

        for(pageId in $rootScope["stree"].spaceArticles){
            sf.inlineDialog(pageId);
        }
    }
    sf.modal.closeDialog = function(){
        AJS.dialog2("#sfdcMetadataSection").hide();
    };

    sf.modal.closeConfirmationDialog = function(){
        AJS.dialog2("#confirmationRemoveDialog").hide();
    };
    sf.updateSelections = function(){
        sf.error = false;
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        if(selectedNodes.length==0){
            sf.error = true;
            sf.errorMessage = 'Please select at least one page';
            return;
        }
        sf.modal.hint = "";
        sf.modal.initDialog(selectedNodes);
        sf.validateNodeSelections(sf.modal,selectedNodes);
        AJS.dialog2("#sfdcMetadataSection").show();
    };
    sf.removeSelections = function(){
        sf.error = false;
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        if(selectedNodes.length==0){
            sf.error = true;
            sf.errorMessage = 'Please select at least one page.';
            return;
        }
        var allBlank = true;
        for(var i = 0;i<selectedNodes.length;i++){
            allBlank = allBlank && !selectedNodes[i].zPageNodeInfo.metadata;
            if(!allBlank){
                break;
            }
        }
        if(allBlank){
            sf.error = true;
            sf.errorMessage = 'The selected pages do not have Knowledge Metadata assigned.';
            return;
        }

        sf.modal.hint = "";

        sf.modal.showError = false;
        sf.modal.showWarning = false;
        sf.modal.showloader = false;
        sf.modal.showMainForm = true;
        sf.modal.showWait = false;
        sf.modal.confirmRemoveDisabled = false;

        sf.modal.showWarning = false;
        for(var i = 0;i<selectedNodes.length;i++){
            if(selectedNodes[i].zPageNodeInfo.published){
                sf.modal.showWarning = true;
                sf.modal.warningMessage = "Knowledge Metadata will be removed only on confluence page metada, "+
                    " published pages will remain published on Salesforce";
                break;
            }
        }
        AJS.dialog2("#confirmationRemoveDialog").show();
    };
    sf.modal.confirmRemove=function(){

        sf.modal.showWait = true;
        sf.modal.confirmRemoveDisabled = true;
        sf.modal.closeRemoveDisabled=true;

        var batches = sf.calculateBatches();

        var confirmRemoveInternal = function(index){
            if(index<batches.length) {
                if(batches.length>1) {
                    var percent = parseInt((index) * 100 / batches.length);
                    sf.modal.hint = "Processing Request: " + percent + "%";
                }

                cTreeRemoteService.removeSalesforceMetadata(batches[index], sf.mode).then(function (result) {
                    window.console.log('removeSectionToPages', result);
                    confirmRemoveInternal(index+1);

                }).catch(function (response) {
                    window.console.log('removeSectionToPages error', response);
                    sf.modal.showWait = false;
                    sf.modal.hint = "";
                    sf.modal.closeRemoveDisabled=false;
                    sf.modal.showMainForm = false;
                    sf.modal.showError = true;
                    sf.modal.showWarning = false;
                    if (response.data && response.data.message) {
                        sf.modal.errorMessage = response.data.message;
                    } else if (response.statusText) {
                        sf.modal.errorMessage = response.statusText;
                    } else {
                        sf.modal.errorMessage = 'Unknown Error';
                    }
                });
            }else{
                sf.modal.showWait = false;
                sf.modal.hint = "Success!";
                sf.modal.confirmRemoveDisabled = false;
                sf.modal.closeRemoveDisabled=false;
                window.setTimeout(
                    function () {
                        AJS.dialog2("#confirmationRemoveDialog").hide();
                        sf.renderTree();
                    }, 1000);
            }
        }
        confirmRemoveInternal(0);

    };
    sf.calculateBatches = function () {
        var BATCH_SIZE = 100;
        var pageIds = cTreeRemoteService.getSelectedPageIds();
        var batches = [];
        var currentBatch = new Array();
        for(var i =0;i<pageIds.length;i++){
            currentBatch.push(pageIds[i]);
            if(currentBatch.length>=BATCH_SIZE){
                batches.push(currentBatch);
                currentBatch = new Array();
            }
        }
        if(currentBatch.length>0){
            batches.push(currentBatch);
        }
        return batches;
    };
    sf.modal.stablish=function(){
        KFService.recordTypeError(false);
        if(sf.modal.data.recordTypes && sf.modal.data.recordTypes.length > 0 && !KFService.selectedRecordType()){
            KFService.recordTypeError(true);
            return;
        }
        sf.modal.showWait = true;
        sf.modal.updateButtonDisabled = true;
        sf.modal.closeAssignDisabled=true;

        var batches = sf.calculateBatches();

        var stablishInternal = function(index){
            if(index<batches.length){
                var request ={
                    pageIds: batches[index],
                    salesforceMetadata:  {
                        categories: KCSService.getSelectedCategories(),
                        recordType: KFService.selectedRecordType(),
                        channels : KFService.selectedChannels()
                    }
                };
                if(batches.length>1) {
                    var percent = parseInt((index) * 100 / batches.length);
                    sf.modal.hint = "Processing Request: " + percent + "%";
                }

                cTreeRemoteService.stablishSalesforceMetadata(request,sf.mode).then(function(result){
                    window.console.log('stablishSectionToPages',result);
                    stablishInternal(index+1);

                }).catch(function(response){
                    window.console.log('stablishSectionToPages error',response);
                    sf.modal.showWait = false;
                    sf.modal.hint = "";
                    sf.modal.showMainForm= false;
                    sf.modal.closeAssignDisabled=false;
                    sf.modal.showError = true;
                    sf.modal.showWarning = false;

                    if(response.data && response.data.message){
                        sf.modal.errorMessage = response.data.message;
                    }else if(response.statusText){
                        sf.modal.errorMessage = response.statusText;
                    }else{
                        sf.modal.errorMessage = 'Unknown Error';
                    }
                });
            }else{
                sf.modal.showWait = false;
                sf.modal.hint = "Success!";
                sf.modal.closeAssignDisabled=false;
                sf.modal.updateButtonDisabled = false;
                window.setTimeout(
                    function(){
                        AJS.dialog2("#sfdcMetadataSection").hide();
                        sf.renderTree();
                    },1000);
            }
        };
        stablishInternal(0);

    };

};
var cTreeRemoteService = function($rootScope,$q,$http) {
    return {
        editMeta: function(pageId) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + pageId + "/salesforce/page-editmeta",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        salesforceCreateMeta: function(spaceKey) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/content/"+spaceKey+"/salesforce/page-createmeta",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        deferred:function(){
            var deferred = $q.defer();
            deferred.resolve();
            return deferred.promise;
        },
        clearAllSelection:function(){
            jzq("#stree").jstree().deselect_all();
        },
        renderTree:function(spaceKey,mode,target){
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/tree/"+target+"?spaceKey="+spaceKey+"&mode="+mode,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                var result = response.data;
                deferred.resolve(result);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getSelectedNodes:function(){
            selectionIds = jzq("#stree").jstree().get_selected();
            var selectedNodes = [];
            for(var i = 0 ; i<selectionIds.length; i++){
                var pageId = selectionIds[i];
                selectedNodes.push($rootScope["stree"].spaceArticles[pageId]);
            }
            return selectedNodes;
        },
        getSelectedPageIds:function(){
            return jzq("#stree").jstree().get_selected();;
        },
        refreshTree:function(){
            $rootScope["stree"].controller.refresh();
        },
        reRender:function(mode){
            $rootScope["stree"].controller.reRender(mode);
        },
        removeSalesforceMetadata:function(request,mode){
            var deferred = $q.defer();
            var req = {
                method: "DELETE",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/sfdc-utils/remove-metadata-bulk?mode="+mode,
                headers: {
                    'Content-Type': "application/json"
                },
                data:request
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        stablishSalesforceMetadata:function(request,mode){
            var deferred = $q.defer();
            var req = {
                method: "PUT",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/sfdc-utils/stablish-metadata-bulk?mode="+mode,
                headers: {
                    'Content-Type': "application/json"
                },
                data:request
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        }
    };
};

var zApp = window.zkbangular.module("src", []);
zApp.factory("cTreeRemoteService",cTreeRemoteService);
cTreeRemoteService.$inject = ["$rootScope","$q","$http"];

loadKnowledgeCategoryComponent(zApp);
loadKnowledgeFieldsComponent(zApp);


zApp.component("stree",{
    bindings: {
        space: '@',
        mode: '@'
    },
    templateUrl: AJS.Data.get("context-path") +
        '/download/resources/com.zagile.confluence.kb.knowledge-bridge:angular-templates/salesforce-confluence-page-tree.html',
    controller: ['$rootScope', '$scope', 'cTreeRemoteService', 'KCSService', 'KFService', SConfluenceTree],
});