AJS.toInit(function(){
    AJS.$('#salesforceDeleteDialogWI').click(function(e){
        e.preventDefault();
        if(AJS.$("#salesforceDeleteDialog").length==0){
            initSalesforceDeleteDialog();
        }else{
            AJS.dialog2("#salesforceDeleteDialog").show();
        }
    });
});

var SalesforceDelete=function($scope,zSfDeleteDataService){
    var sf = this;
    sf.isShowing = {
        wait:false,
        mainForm:false,
        loader: true
    };
    sf.error = false;
    sf.data = {};
    sf.contextPath = AJS.contextPath();
    sf.waitIconUrl = sf.contextPath+'/images/icons/wait.gif';
    sf.deleteDisabled = true;
    sf.isDeletedInSalesforce = false;

    sf.formatDate=function(longDate){
        var date = new Date(longDate);
        return date.toLocaleString();
    };
    sf.deleteArticle=function(){
        var handleError = function(response){
            sf.isShowing.wait = false;
            sf.deleteDisabled = false;

            sf.error = true;

            if (response.data && response.data.message) {
                sf.errorMessage = response.data.message;
            } else if (response.statusText) {
                sf.errorMessage = response.statusText;
            } else {
                sf.errorMessage = 'Unknown Error';
            }
        };
        sf.deleteDisabled = true;
        sf.isShowing.wait = true;

        if(sf.isDeletedInSalesforce){
            sf.error = true;
            zSfDeleteDataService.deleteEntityProperties().then(function (result) {
                window.console.log('deleteEntityProperties', result);
                AJS.dialog2("#salesforceDeleteDialog").hide();
                window.location.reload();
            }).catch(function (response) {
                window.console.log('deleteArticle error', response);
                handleError(response);
            });
        }else {
            sf.error = false;
            zSfDeleteDataService.deleteArticle().then(function (result) {
                window.console.log('deleteArticle', result);
                AJS.dialog2("#salesforceDeleteDialog").hide();
                window.location.reload();
            }).catch(function (response) {
                window.console.log('deleteArticle error', response);
                handleError(response);
            });
        }
    };

    sf.calculateKAVsToShow = function(translation){
        var kav = translation.knowledgeArticleVersionId;
        var draftKav = translation.draftKnowledgeArticleVersionId;
        var onlineKav = translation.onlineKnowledgeArticleVersionId;

        translation.resultPageShowStoredKAV = kav && true;
        if(!kav || ( kav !== draftKav && kav !== onlineKav )){
            translation.resultPageShowDrafKAV = draftKav && true;
            translation.resultPageShowOnlineKAV = onlineKav && true;
        }
    };


    sf.editMeta = function(){
        zSfDeleteDataService.editMeta().then(function(result){
            window.console.log('edit meta',result);
            sf.data = result;

            if( !sf.data.translations ){
                sf.errorMessage = "Not found any translation";
                sf.deleteDisabled = false;

            }
            else if(sf.data.translations.length === 0){
                sf.error = true;
                sf.errorMessage = "Error, no publications found";
            }else {
                sf.deleteDisabled = false;
                sf.isShowing.publishedPage = true;
                sf.isShowing.mainForm = true;

                sf.data.translations.forEach(function(translation){
                    sf.calculateKAVsToShow(translation);
                });
            }
        }).catch(function(response){
            window.console.log('edit meta error',response);
            sf.error = true;
            if(response.data && response.data.message){
                sf.errorMessage = response.data.message;
            }else if(response.statusText){
                sf.errorMessage = response.statusText;
            }else{
                sf.errorMessage = 'Unknown Error';
            }
        }).finally(function(){
            sf.isShowing.loader = false;
        });
    };


    zSfDeleteDataService.isDeletedInSalesforce().then(function(result){
        window.console.log('isDeletedInSalesforce',result);
        if(!result){
            sf.editMeta();
        }else{
            sf.isDeletedInSalesforce = true;
            sf.error = true;
            sf.isShowing.loader = false;
            sf.deleteDisabled = false;
            sf.errorMessage = 'The Knowledge Article has been deleted in Salesforce, press delete to sync this Page with Salesforce';
        }
    }).catch(function(response){
        sf.editMeta();
    });


    AJS.dialog2("#salesforceDeleteDialog").show();
    //-------------
    sf.closeDialog=function(){
        AJS.dialog2("#salesforceDeleteDialog").hide();
    };
}
var zSfDeleteDataService = function($q,$http) {
    return{
        editMeta: function() {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/page-editmeta",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        deleteArticle: function() {
            var deferred = $q.defer();
            var req = {
                method: "DELETE",
                url: AJS.contextPath()+
                    "/rest/kb-internal/1.0/content/"+AJS.params.pageId+"/salesforce/delete-publication",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        isDeletedInSalesforce:function(){
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/sfdc-utils/isDeleted/"+AJS.params.pageId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        deleteEntityProperties:function(){
            var deferred = $q.defer();
            var req = {
                method: "DELETE",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/sfdc-utils/deleteProperties/"+AJS.params.pageId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        }
    };
}

function initSalesforceDeleteDialog(){
    //--inject dialog with angular component to body
    var dialog2Str = '';
    dialog2Str += '<section role="dialog" id="salesforceDeleteDialog" class="aui-layer aui-dialog2 aui-dialog2-medium" aria-hidden="true">';
    dialog2Str += '<div ng-app="sf-dlt-src">';
    dialog2Str += '<salesforce-delete>';
    dialog2Str += '</salesforce-delete>';
    dialog2Str += '</div>';
    dialog2Str += '</section>';
    AJS.$(document.body).append(AJS.$(dialog2Str));

    //--create angular app, initiate component and relate controller and services
    var salesforceDelete = window.zkbangular.module("sf-dlt-src", []);
    salesforceDelete.factory("zSfDeleteDataService",zSfDeleteDataService);
    zSfDeleteDataService.$inject = ["$q","$http"];

    salesforceDelete.component("salesforceDelete",{
        templateUrl: AJS.Data.get("context-path") +
            '/download/resources/com.zagile.confluence.kb.knowledge-bridge:salesforce-modal-resources/salesforce-delete.html',
        controller: ['$scope', 'zSfDeleteDataService', SalesforceDelete]
    });

    //--compile angular app
    var injector = window.zkbangular.injector(["ng", "sf-dlt-src"]);
    injector.invoke(function($compile, $rootScope) {
        $compile(AJS.$("div[ng-app='sf-dlt-src']"))($rootScope);
        $rootScope.$apply();
    });
}