AJS.toInit(function() {
	AJS.$('#salesforceUpdateDialog, #salesforceUpdateDialogBtn').click(function(e) {
		e.preventDefault();
		if (AJS.$("#sfPublishUpdateDialog").length == 0) {
			initSalesforcePublishUpdateDialog(false);
		} else {
            sfRestartDialogIfNeeded();

		}
	});
	AJS.$('#salesforcePublishDialog, #salesforcePublishDialogBtn').click(function(e) {
		e.preventDefault();
		if (AJS.$("#sfPublishUpdateDialog").length == 0) {
			initSalesforcePublishUpdateDialog(true);
		} else {
            sfRestartDialogIfNeeded();
		}
	});
});

function sfRestartDialogIfNeeded() {
	if (zAgileIsPublishContext && zAgileIsLabelsContext && zAgileInputStage && zAgilePublishControllerReference != null) {
		zAgilePublishControllerReference.internalInit();
	} else if (!zAgileIsPublishContext && zAgileUpdateSectionNull) {
		zAgilePublishControllerReference.internalInit();
	}
	AJS.dialog2("#sfPublishUpdateDialog").show();
}
var zAgileIsPublishContext;
var zAgileIsLabelsContext = false;
var zAgileInputStage = true;
var zAgilePublishControllerReference = null;
var zAgileUpdateSectionNull = false;
var SalesforcePublishUpdate = function($scope, sfDataService, KCSService,KFService) {
	var sf = this;
	zAgilePublishControllerReference = sf;
	sf.internalInit = function() {
		sf.maxEntries = 5;
		sf.isLicensed = false;
		sf.isPublish = zAgileIsPublishContext;
		sf.title = sf.isPublish ? "Publish Page in Salesforce" : "Update Page in Salesforce";
		sf.hint = '';
		sf.publishUpdateButtonLabel = sf.isPublish ? 'Publish' : 'Update';
		sf.contextPath = AJS.contextPath();
		sf.waitIconUrl = sf.contextPath + '/images/icons/wait.gif';
		sf.isShowing = {
			wait: false,
			mainForm: false,
			loader: true,
			publishedPage: false,
			resultPage: false
		};
		sf.DAYS_REMAINING_TO_WARN = 30;
		sf.resultPageShowStoredKAV = false;
        sf.resultPageShowDrafKAV = false;
        sf.resultPageShowOnlineKAV = false;
        sf.translationData = {};
		sf.error = false;
		sf.warning = false;
		sf.publishUpdateDisabled = true;
		sf.publishMakePublishButton = false;
		sf.publishMakePublishButtonDisabled = true;
		sf.publishUpdateShow = true;
		sf.data = {};
		sf.executed = false;
        sf.changesInSalesforce = false;
		AJS.dialog2("#sfPublishUpdateDialog").show();


        sfDataService.isSfdcLicensed().then(function(isSfdcLicensed) {
            window.console.log('isSfdcLicensed',isSfdcLicensed);
            if(isSfdcLicensed.daysToExpire && isSfdcLicensed.daysToExpire!=-1 && isSfdcLicensed.daysToExpire<=sf.DAYS_REMAINING_TO_WARN){
                AJS.flag({
                    type: 'warning',
                    body: 'Your Knowledge:Bridge license will expire in '+isSfdcLicensed.daysToExpire+' days.',
                });
            }

			sf.isLicensed = true;
			if (sf.isPublish) {
				sf.recordTypeError = false;
				sf.showStep2 = false;
				sf.showNextButton = true;
				sf.showBackButton = false;
				sf.draft = true;
				sfDataService.createMeta().then(function (result) {
					window.console.log('create meta', result);
					KFService.setMetadata(result);

					sf.data = result;
					if (sf.data.categories == null || sf.data.categories.length == 0) {
						sf.showNextPage(true);
					} else {
						KCSService.setCategoriesMetadata(result);
					}
					sf.isShowing.mainForm = true;
					sf.publishUpdateDisabled = false;

					if (sf.data.warning) {
						sf.warning = true;
						sf.warningMessage = sf.data.warningMessage;
					}
					if (sf.data.metadata) {
						KFService.setData(sf.data.metadata);
						if (sf.data.metadata.categories) {
							KCSService.setCategories(sf.data.metadata.categories);
						}
					}

				}).catch(function (response) {
					window.console.log('error', response);

					sf.error = true;
					if (response.data && response.data.message) {
						sf.errorMessage = response.data.message;
					} else if (response.statusText) {
						sf.errorMessage = response.statusText;
					} else {
						sf.errorMessage = 'Unknown Error';
					}
				}).finally(function () {
					sf.isShowing.loader = false;
				});
			} else {
				sfDataService.editMeta().then(function (result) {
					window.console.log('edit meta', result);
					sf.data = result;

					var editMetaCallBack = function () {
						if (sf.data.translations.length == 0) {
							sf.error = true;
							sf.errorMessage = "Error, no publications found";
						} else {
							sf.publishUpdateDisabled = false;
							sf.isShowing.publishedPage = true;
							sf.translationData = result.translations[0];
							sf.calculateKAVsToShow();
							sf.isShowing.mainForm = true;
						}
					};

					if (sf.data.translations.length > 0 && sf.data.translations[0].knowledgeArticleVersionId == sf.data.translations[0].draftKnowledgeArticleVersionId) {
						sfDataService.isChangedInSalesforce().then(function (result) {
							window.console.log('isChangedInSalesforce', result);
							sf.changesInSalesforce = result.changesInSalesforce;
						}).finally(function () {
							editMetaCallBack();
						});
					} else {
						editMetaCallBack();
					}

				}).catch(function (response) {
					window.console.log('edit meta error', response);
					sf.error = true;

					if (response.data && response.data.message) {
						sf.errorMessage = response.data.message;
					} else if (response.statusText) {
						sf.errorMessage = response.statusText;
					} else {
						sf.errorMessage = 'Unknown Error';
					}
				}).finally(function () {
					sf.isShowing.loader = false;
				});
			}
        }).catch(function(response) {
            window.console.log('error',response);

            sf.error = true;
            if(response.data && response.data.message){
                sf.errorMessage = response.data.message;
            }else if(response.statusText){
                sf.errorMessage = response.statusText;
            }else{
                sf.errorMessage = 'Unknown Error';
            }
        }).finally(function() {
            sf.isShowing.loader = false;
        });
	}
    sf.$onInit=function() {
        sf.internalInit();
    };

	sf.showNextPage = function(hideBackButton) {
		sf.showStep2 = true;
		sf.showNextButton = false;
		sf.showBackButton = !hideBackButton;
	}

	sf.showBackPage = function() {
		sf.showStep2 = false;
		sf.showNextButton = true;
		sf.showBackButton = false;
	}

	sf.closeDialog = function() {
		AJS.dialog2("#sfPublishUpdateDialog").hide();
		if(sf.executed)
			window.location.reload();
	};
	
	sf.formatDate = function(longDate){
		var date = new Date(longDate);
		return date.toLocaleString();
	};

	sf.validateInternal = function(request, callback) {
		sf.publishUpdateDisabled = true;
		sf.isShowing.wait = true;
		sf.isShowing.publishedPage = false;
		sfDataService.validate(request).then(function(result) {
			window.console.log('validate', result);
			var maxResults = 3;
			var brokenLinks = 0;
			sf.validation = {
                brokenPageLinks: [],
				blackListedOrUnknownMacros: []
			};
            for (var i = 0; i < result.pageLinks.length; i++) {
                if (result.pageLinks[i].knowledgeArticleId == null) {
                    brokenLinks++;
                    result.pageLinks[i].hidden = (brokenLinks > maxResults);
                    sf.validation.brokenPageLinks.push(result.pageLinks[i]);
                }
            }
			for( i = 0; i < result.pageMacros.length; i++){
				if( result.pageMacros[i].blackListed || result.pageMacros[i].unknown ){
					sf.validation.blackListedOrUnknownMacros.push(
						{ id: result.pageMacros[i].id,
						  name:	result.pageMacros[i].name,
						  blackListed: result.pageMacros[i].blackListed,
						  unknown: result.pageMacros[i].unknown
						});
				}
			}

			sf.hiddenItems = brokenLinks - maxResults;
			if (brokenLinks > 0 || sf.validation.blackListedOrUnknownMacros.length > 0) {
				sf.validationForm = true;
				sf.publishUpdateButtonLabel = 'Confirm';
				sf.isShowing.mainForm = false;

				sf.publishUpdateDisabled = false;
				sf.isShowing.wait = false;
			} else {
				callback(request);
			}
		}).catch(function(response) {
			window.console.log('validate error', response);
			sf.isShowing.mainForm = false;
			sf.error = true;
			sf.isShowing.wait = false;

			if (response.data && response.data.message) {
				sf.errorMessage = response.data.message;
			}else if(response.statusText){
                sf.errorMessage = response.statusText;
            }else{
                sf.errorMessage = 'Unknown Error';
            }
			sf.publishUpdateButtonLabel = 'Confirm';

			sf.publishUpdateDisabled = false;
			sf.isShowing.wait = false;
		}).finally(function() {

		});
	};

	sf.monitorPublishing = function() {
		sfDataService.monitor(sf.monitoringId).then(function(result) {
			window.console.log('monitoring', result);

			if(result.isError){
                sf.isShowing.wait = false;
                sf.error = true;
                sf.errorMessage = result.status;
                sf.hint = 'Error publishing';
                return;
			}

			if(result.status){
				sf.hint =result.status;
				setTimeout(function(){sf.monitorPublishing();},4000);
			}else{
				sf.summaryResults();
			}
		}).catch(function(response) {
			window.console.log('monitoring error', response);
            sf.isShowing.wait = false;
            sf.error = true;
            sf.errorMessage = response;

		}).finally(function() {
		});
	};

	sf.summaryResults = function() {
		sf.isShowing.wait = false;
		sf.hint = '';
		
		if (sf.isPublish) {
			sfDataService.summaryResults().then(function(result) {
				window.console.log('summaryResults', result);
				if (result.error) {
					sf.error = true;
					sf.errorMessage = result.errorMessage;
				} else {
					sf.isShowing.resultPage = true;
					sf.translationData = result.translations[0];
                    sf.calculateKAVsToShow( );
					sf.publishUpdateResult = result;

					if (sf.isPublish && sf.draft) {
						sf.publishMakePublishButton = true;
						sf.publishMakePublishButtonDisabled = false;
						sf.publishUpdateShow = false;
					}
					
					if(result.warning){
						sf.warning = true;
						sf.warningMessage = result.warningMessage;
					}
				}
			}).catch(function(response) {
				window.console.log('summaryResults error', response);
                sf.error = true;
                if(response.data && response.data.message){
                    sf.errorMessage = response.data.message;
                }else if(response.statusText){
                    sf.errorMessage = response.statusText;
                }else{
                    sf.errorMessage = 'Unknown Error';
                }

                if(response.data && response.data["stack-trace"]){
                    sf.errorMessage += " ("+response.data["stack-trace"].substring(0, 500) + ") ";
                }

			}).finally(function() {

			});
		}
		else{
			sfDataService.updateSummaryResults().then(function(result) {
				window.console.log('updateSummaryResults', result);
				if (result.error) {
					sf.error = true;
					sf.errorMessage = result.errorMessage;
				} else {
					sf.isShowing.resultPage = true;
                    sf.translationData = result.translations[0];
					sf.calculateKAVsToShow( );
					sf.publishUpdateResult = result;

					if (sf.isPublish && sf.draft) {
						sf.publishMakePublishButton = true;
						sf.publishMakePublishButtonDisabled = false;
						sf.publishUpdateShow = false;
					}
					
					if(result.warning){
						sf.warning = true;
						sf.warningMessage = result.warningMessage;
					}
				}
			}).catch(function(response) {
				window.console.log('updateSummaryResults error', response);

			}).finally(function() {

			});
		}
	};

	sf.calculateKAVsToShow = function(){
        var kav = sf.translationData.knowledgeArticleVersionId;
        var draftKav = sf.translationData.draftKnowledgeArticleVersionId;
        var onlineKav = sf.translationData.onlineKnowledgeArticleVersionId;

		sf.resultPageShowStoredKAV = kav && true;
        if(!kav || ( kav !== draftKav && kav !== onlineKav )){
            sf.resultPageShowDrafKAV = draftKav && true;
            sf.resultPageShowOnlineKAV = onlineKav && true;
        }
	};

	sf.publishConfirmation = function(request) {
		zAgileInputStage = false;

		sf.validationForm = false;
		sf.isShowing.mainForm = true;
		sf.publishUpdateButtonLabel = 'Publish';
		sf.publishUpdateDisabled = true;

        KFService.disabledRecordType(true);
        AJS.$("salesforce-update-metadata #channels-select").auiSelect2("enable", false)
		sf.disabledDraft = true;
		sf.isShowing.wait = true;
		sfDataService.publish(request).then(function(result) {
			window.console.log('publish', result);
			sf.monitoringId = result.monitoringId;
			sf.monitorPublishing();
		}).catch(function(response) {
			window.console.log('publish error', response);
			sf.isShowing.mainForm = false;
			sf.error = true;
			sf.isShowing.wait = false;

			if (response.data && response.data.message) {
				sf.errorMessage = response.data.message;
			}else if(response.statusText){
                sf.errorMessage = response.statusText;
            }else{
                sf.errorMessage = 'Unknown Error';
            }
		}).finally(function() {

		});
	};

	sf.publishPage = function() {
        KFService.recordTypeError(false);
		if(sf.data.recordTypes && sf.data.recordTypes.length > 0 && !KFService.selectedRecordType()){
            KFService.recordTypeError(true);
			return;
		}

		sf.publishInProgress = true;
		var request = {
			pageId: AJS.params.pageId,
			categories: KCSService.getSelectedCategories(),
			channels: KFService.selectedChannels(),
			recordType: KFService.selectedRecordType()?KFService.selectedRecordType().id:null,
			translations: [{
				language: sf.data.defaultLanguage,
				draft: sf.draft
			}]
		};
		if (sf.publishUpdateButtonLabel == 'Confirm') {
			sf.publishConfirmation(request);
			return;
		}

		sf.validateInternal(request, sf.publishConfirmation);

	};
	
	sf.upgradeConfirmation=function(request){
		sf.validationForm = false;
		sf.isShowing.mainForm = true;
		sf.publishUpdateButtonLabel = 'Update';

		sf.publishUpdateDisabled = true;
		sf.isShowing.wait = true;
		sf.isShowing.publishedPage = false;
		sfDataService.update(request).then(function(result){
			window.console.log('update',result);
			sf.monitoringId=result.monitoringId;

			sf.monitorPublishing();
		}).catch(function(response){
			window.console.log('update error',response);
			sf.isShowing.mainForm = false;
			sf.error = true;
			sf.isShowing.wait = false;

			if(response.data && response.data.message){
				sf.errorMessage = response.data.message;
			}else if(response.statusText){
                sf.errorMessage = response.statusText;
            }else{
                sf.errorMessage = 'Unknown Error';
            }
		}).finally(function(){

		});
	};
	
	sf.upgradePage=function(){
		var request ={
				pageId:AJS.params.pageId,
				pageVersion:sf.data.pageVersion,
				translations:[
					{
						language:sf.data.translations[0].language,
						draft:sf.data.translations[0].draft
					}
				]
		};
		if(sf.publishUpdateButtonLabel == 'Confirm'){
			sf.upgradeConfirmation(request);
			return;
		}
		sf.validateInternal(request,sf.upgradeConfirmation);		
	};

	sf.publishUpdatePage = function() {
		sf.executed = true;
		if (sf.isPublish) {
			sf.publishPage();
		} else {
			sf.upgradePage();
		}
	};

	sf.changeDraftFlag = function(draft) {
		var articleId = sf.publishUpdateResult.knowledgeArticleId;
		var locale = sf.publishUpdateResult.translations[0].language;
		sf.publishMakePublishButtonDisabled = true;
		sf.isShowing.wait = true;
		sfDataService.changeDraft(articleId, locale, draft).then(function(result) {
			window.console.log('changeDraft', result);
			if(result.warning){
				sf.warning = true;
				sf.warningMessage = result.warningMessage;
			}
		}).catch(function(response) {
			window.console.log('changeDraft error', response);
			sf.isShowing.mainForm = false;
			sf.error = true;

			if (response.data && response.data.message) {
				sf.errorMessage = response.data.message;
			}else if(response.statusText){
                sf.errorMessage = response.statusText;
            }else{
                sf.errorMessage = 'Unknown Error';
            }
		}).finally(function() {
			sf.isShowing.wait = false;
		});
	};
	sf.showAllLinks=function(){
		for(var i = 0 ; i<sf.validation.brokenPageLinks.length;i++){
			sf.validation.brokenPageLinks[i].hidden = false;
		}
		sf.hiddenItems=0;
	};
}
var sfDataService = function($q, $http) {
	return {
		changeDraft: function(articleId, locale, draft) {
			var deferred = $q.defer();
			var req = {
				method: "POST",
				url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/publish/" + articleId + "/online" + "?locale=" + locale,
				headers: {
					'Content-Type': "application/json"
				},
				data: {}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise;
		},
		createMeta: function() {
			var deferred = $q.defer();
			var req = {
				method: "GET",
				url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/page-createmeta",
				headers: {
					'Content-Type': "application/json"
				}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise;
		},
		publish: function(request) {
			var deferred = $q.defer();
			var req = {
				method: "POST",
				url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/publish",
				headers: {
					'Content-Type': "application/json"
				},
				data: request
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise;
		},
		editMeta: function() {
			console.log("EDIT META SERVICE");
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/page-editmeta",
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		update: function(request) {
			var deferred = $q.defer();
			var req = {
					method: "PUT",
					url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/update",
					headers: {
						'Content-Type': "application/json"
					},
					data:request
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		monitor: function(monitoringId) {
			var deferred = $q.defer();
			var req = {
				method: "GET",
				url: AJS.contextPath() + "/rest/kb-internal/1.0/content/process/" + monitoringId + "/status",
				headers: {
					'Content-Type': "application/json"
				}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise;
		},
		summaryResults: function() {
			var deferred = $q.defer();
			var req = {
				method: "GET",
				url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/summary",
				headers: {
					'Content-Type': "application/json"
				}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise;
		},
		updateSummaryResults: function() {
			var deferred = $q.defer();
			var req = {
				method: "GET",
				url: AJS.contextPath() + "/rest/kb-internal/1.0/content/" + AJS.params.pageId + "/salesforce/update/summary",
				headers: {
					'Content-Type': "application/json"
				}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise;
		},
		validate: function(request) {
			var deferred = $q.defer();
			var req = {
				method: "POST",
				url: AJS.contextPath() + "/rest/kb-internal/1.0/content/process/salesforce/validate",
				headers: {
					'Content-Type': "application/json"
				},
				data: request
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise;
		},
        isChangedInSalesforce:function(){
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/sfdc-utils/detect/"+AJS.params.pageId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        isSfdcLicensed:function(){
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/sfdc-utils/isSfdcLicensed",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        }
	};
}

function initSalesforcePublishUpdateDialog(ppublish) {

	zAgileIsPublishContext = ppublish;
	//--inject dialog with angular component to body
	var dialog2Str = '';
	dialog2Str += '<section role="dialog" id="sfPublishUpdateDialog" class="aui-layer aui-dialog2 aui-dialog2-medium" aria-hidden="true" data-aui-modal="true" style="width: 650px;">';
	dialog2Str += '<div ng-app="sf-upd-src">';
	dialog2Str += '<salesforce-publish-update>';
	dialog2Str += '</salesforce-publish-update>';
	dialog2Str += '</div>';
	dialog2Str += '</section>';
	AJS.$(document.body).append(AJS.$(dialog2Str));

	//--create angular app, initiate component and relate controller and services
	salesforceUpdate = window.zkbangular.module("sf-upd-src", []);
	salesforceUpdate.factory("sfDataService", sfDataService);
	sfDataService.$inject = ["$q", "$http"];


	loadKnowledgeCategoryComponent(salesforceUpdate);
	loadKnowledgeFieldsComponent(salesforceUpdate);

	salesforceUpdate.component("salesforcePublishUpdate", {
		templateUrl: AJS.Data.get("context-path") +
			'/download/resources/com.zagile.confluence.kb.knowledge-bridge:salesforce-modal-resources/salesforce-publish-or-update.html',
		controller: ['$scope', 'sfDataService', 'KCSService', 'KFService', SalesforcePublishUpdate]
	});

	//--compile angular app
	var injector = window.zkbangular.injector(["ng", "sf-upd-src"]);
	injector.invoke(function ($compile, $rootScope) {
		$compile(AJS.$("div[ng-app='sf-upd-src']"))($rootScope);
		$rootScope.$apply();
	});
}