
var ZConfluenceTree=function($rootScope,$scope,cTreeRemoteService){
    var zd = this;

    zd.free = {};
    zd.descendants = {};

    zd.treeLoader=false;
    zd.showWait = false;
    zd.saveDescendantsDisabled = false;
    zd.error = false;
    zd.success  = false;
    zd.free.dialogInitiated = false;
    zd.contextPath=AJS.contextPath();
    zd.waitIconUrl = AJS.contextPath()+'/images/icons/wait.gif';


    zd.$onInit=function(){
        $rootScope["ztree"]={};
        $rootScope["ztree"].spaceArticles = {};
        $rootScope["ztree"].controller = zd;

        zd.renderTree();
    };
    zd.reRender=function(mode){
        zd.mode = mode;
        zd.renderTree();
    };
    zd.refresh=function(){
        zd.renderTree();
    };
    zd.renderTree=function(){
        if(zd.mode==""){
            return;
        }
        jzq('#ztree').jstree("destroy").empty();
        $rootScope["ztree"].spaceArticles = {};
        zd.treeLoader=true;
        cTreeRemoteService.renderTree(zd.space,zd.mode).then(function(result){
            window.console.log('tree meta',result);
            zd.fillRootAndTree(result);
        }).catch(function(response){
            window.console.log('tree meta error',response);
            zd.error = true;
            if(response.data && response.data.message){
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage = response.statusText;
            }else{
                zd.errorMessage= 'Unknown Error';
            }
        }).finally(function(){
            zd.treeLoader=false;
        });
    };
    zd.buildPublications=function(translations){
        var html="<a href='"+translations[0].url+
            "' target='_blank'>"+translations[0].locale+"</a>";
        for(var j = 1;j<translations.length;j++){
            html+=", <a href='"+translations[j].url+"' target='_blank'>"+translations[j].locale+"</a>";
        }
        return html;
    };
    zd.loadCategoryDescription=function(pageId,sectionId){
        jzq("td[zd-description='"+pageId+"']").css('color','black');
        if(sectionId==null){
            cTreeRemoteService.deferred().then(function(result){
                jzq("td[zd-description='"+pageId+"']").html("Zendesk Section not assigned, "+
                    "Page is published but cannot be updated until you assign a Section.");
            });
            return;
        }
        cTreeRemoteService.getCategoryDescription(sectionId).then(function(result){
            window.console.log('getCategoryDescription meta',result);
            jzq("td[zd-description='"+pageId+"']").html(result.description);
            $rootScope["ztree"].spaceArticles[pageId].zPageNodeInfo.catDesc = result.description;
        }).catch(function(response){
            window.console.log('getCategoryDescription error',response);

            var errorMessage = "";
            if(response.data && response.data.message){
                errorMessage = response.data.message;
            }else if(response.statusText){
                errorMessage = response.statusText;
            }else{
                errorMessage= 'Unknown Error';
            }
            jzq("td[zd-description='"+pageId+"']").css('color','red');
            jzq("td[zd-description='"+pageId+"']").html(errorMessage);
        }).finally(function(){
        });
    }
    zd.showInfo=function(pageId){
        var pageIdStr = pageId + "";
        AJS.$("#page-info").html("");
        var page = $rootScope["ztree"].spaceArticles[pageIdStr];

        var infoHTML = "<table class=\"aui summary\">";
        infoHTML += "<tbody>";
        infoHTML += "<tr>";
        infoHTML += "<th>Title:</th>";
        infoHTML += "<td><a href='"+AJS.contextPath()+page.pageUrl+"' target='_blank'>"+page.pageTitle+"</a></td>"
        infoHTML += "</tr>";

        if(page.zPageNodeInfo.published){
            infoHTML += "<tr>";
            infoHTML += "<th>Zendesk Section:</th>";
            if(page.zPageNodeInfo.catDesc){
                infoHTML += "<td>"+page.zPageNodeInfo.catDesc+"</td>";
            }else{
                infoHTML += "<td zd-description='"+pageIdStr+"'><img src='"+ AJS.contextPath()+"/images/icons/wait.gif'/></td>";
                zd.loadCategoryDescription(pageIdStr,page.zPageNodeInfo.sectionId);
            }
            infoHTML += "</tr>";

            infoHTML += "<tr>";
            infoHTML += "<th>Last Activity:</th>";
            infoHTML += "<td>"+page.zPageNodeInfo.lastActivity+" by ";
            infoHTML += "<a href='"+AJS.contextPath()+"/display/~"+page.zPageNodeInfo.lastActivityUserName+
                "' target='_blank'>";
            if(page.zPageNodeInfo.lastActivityUserAvatar){
                infoHTML += "<img height='16' width='16' src='"+ page.zPageNodeInfo.lastActivityUserAvatar+"'/>&nbsp;";
            }
            infoHTML += page.zPageNodeInfo.lastActivityUserFullName+"</a>"
            infoHTML += "</td>";
            infoHTML += "</tr>";

            infoHTML += "<tr>";
            infoHTML += "<th>Publications:</th>";
            infoHTML += "<td>"+zd.buildPublications(page.zPageNodeInfo.translations)+"</td>";
            infoHTML += "</tr>";

        }else{
            if(page.zPageNodeInfo.sectionId){
                infoHTML += "<tr>";
                infoHTML += "<th>Zendesk Section:</th>";
                if(page.zPageNodeInfo.catDesc){
                    infoHTML += "<td>"+page.zPageNodeInfo.catDesc+"</td>";
                }else{
                    infoHTML += "<td zd-description='"+pageIdStr+"'><img src='"+ AJS.contextPath()+"/images/icons/wait.gif'/></td>";
                    zd.loadCategoryDescription(pageIdStr,page.zPageNodeInfo.sectionId);
                }
                infoHTML += "</tr>";
            }
            infoHTML += "<tr>";
            infoHTML += "<th></th>";
            infoHTML += "<td><b>This page has not been published on Zendesk</b></td>";
            infoHTML += "</tr>";
        }

        infoHTML += "</tbody>";
        infoHTML += "</table>";
        return infoHTML;
    };
    zd.inlineDialog=function(pageId){
        AJS.InlineDialog(AJS.$("#link_"+pageId), pageId,
            function(content, trigger, showPopup) {
                var pageIdLink = AJS.$(trigger).attr('pageId');
                var htmlInfo = zd.showInfo(pageIdLink);
                content.css({"padding":"20px"}).html(htmlInfo);
                showPopup();
                return false;
            }
        );
    };
    zd.nodeMenu=function(node) {
        var items = {
            'item1': {
                'label': 'Select Children',
                'action': function() {
                    jzq("#ztree").jstree().select_node(node.id);
                    for(var i = 0;i<node.children.length;i++){
                        jzq("#ztree").jstree().select_node(node.children[i]);
                    }
                }
            },
            'item2': {
                'label': 'Select Descendants',
                'action': function() {
                    jzq("#ztree").jstree().select_node(node.id);
                    for(var i = 0;i<node.children_d.length;i++){
                        jzq("#ztree").jstree().select_node(node.children_d[i]);
                    }
                }
            },
            'item3': {
                'label': 'Unselect Children',
                'action': function () {
                    jzq("#ztree").jstree().deselect_node(node.id);
                    for(var i = 0;i<node.children.length;i++){
                        jzq("#ztree").jstree().deselect_node(node.children[i]);
                    }
                }
            },
            'item4': {
                'label': 'Unselect Descendants',
                'action': function () {
                    jzq("#ztree").jstree().deselect_node(node.id);
                    for(var i = 0;i<node.children_d.length;i++){
                        jzq("#ztree").jstree().deselect_node(node.children_d[i]);
                    }
                }
            }
        }
        if (node.type != 'parent') {
            delete items.item1;
            delete items.item2;
            delete items.item3;
            delete items.item4;
        }

        return items;
    };
    zd.fillTree = function(pageParent,nodeParent,level){
        level++;
        if(level>2 && zd.mode == 'descendants'){
            return;
        }
        for(var i = 0;i<pageParent.childs.length;i++){
            var nodeChild = {};
            nodeChild.text = zd.buildText(pageParent.childs[i]);
            nodeChild.id = pageParent.childs[i].pageId;
            if(pageParent.childs[i].childs.length>0){
                nodeChild.type= "parent";
            }else{
                nodeChild.type= "leaf";
            }
            $rootScope["ztree"].spaceArticles[pageParent.childs[i].pageId] = pageParent.childs[i];
            $rootScope["ztree"].spaceArticles[pageParent.childs[i].pageId].level = level;
            $rootScope["ztree"].spaceArticles[pageParent.childs[i].pageId].parent = pageParent;

            nodeChild.state = {};
            nodeChild.children = [];
            nodeChild.state.opened=false;

            nodeChild.icon = "jstree-file";
            nodeParent.children.push(nodeChild);

            zd.fillTree(pageParent.childs[i],nodeChild,level);
        }
    };
    zd.buildText = function(pageNode){
        if(zd.mode!= 'free'){
            if(pageNode.zPageNodeInfo.sectionId||pageNode.zPageNodeInfo.categoryId){
                return '<span id="link_'+pageNode.pageId+'"><span class="aui-icon aui-icon-small aui-iconfont-edit-small" title="Zendesk Section assigned"></span>&nbsp;'+
                    '<a>'+pageNode.pageTitle+'</a></span>';
            }
            return '<span id="link_'+pageNode.pageId+'"><a>'+pageNode.pageTitle+'</a></span>';
        }
        if(pageNode.zPageNodeInfo.published){
            return '<span class="zui-icon zui-icon-checkcloud" title="Published on Zendesk"></span>&nbsp;'+
                '<a href="#" id="link_'+pageNode.pageId+'" pageId="'+pageNode.pageId+'">'+
                pageNode.pageTitle+'</a>';
        }else if(pageNode.zPageNodeInfo.sectionId){
            return '<span class="aui-icon aui-icon-small aui-iconfont-edit-small" title="Zendesk Section assigned"></span>&nbsp;'+
                '<a href="#" id="link_'+pageNode.pageId+'" pageId="'+pageNode.pageId+'">'+
                pageNode.pageTitle+'</a>';
        }
        return '<a href="#" id="link_'+pageNode.pageId+'" pageId="'+pageNode.pageId+'">'+
            pageNode.pageTitle+'</a>';
    };
    zd.fillRootAndTree=function(spaceTree){
        var jstree = {};
        jstree.core = {};
        jstree.core.data = [];

        jstree.plugins = [];
        jstree.plugins.push("types");
        jstree.plugins.push("contextmenu");

        jstree.types = {};
        jstree.types.parent={};
        jstree.types.leaf={};

        jstree.contextmenu = {};
        jstree.contextmenu.select_node = false;

        if(zd.mode == 'free'){
            jstree.contextmenu.items = zd.nodeMenu;

            jstree.plugins.push("checkbox");

            jzq.jstree.defaults.checkbox.keep_selected_style = true;
            jzq.jstree.defaults.checkbox.whole_node = true;
            jzq.jstree.defaults.checkbox.three_state = false;
            jzq.jstree.defaults.checkbox.cascade = "";
        }else{
            jstree.contextmenu.items = {};
        }

        var level = 1;
        for(var i = 0;i<spaceTree.root.childs.length;i++){
            var nodeChild = {};
            nodeChild.text = zd.buildText(spaceTree.root.childs[i]);
            nodeChild.id = spaceTree.root.childs[i].pageId;
            if(spaceTree.root.childs[i].childs.length>0){
                nodeChild.type= "parent";
            }else{
                nodeChild.type= "leaf";
            }
            $rootScope["ztree"].spaceArticles[spaceTree.root.childs[i].pageId] = spaceTree.root.childs[i];
            $rootScope["ztree"].spaceArticles[spaceTree.root.childs[i].pageId].level = level;
            $rootScope["ztree"].spaceArticles[spaceTree.root.childs[i].pageId].parent = null;
            nodeChild.state = {};
            nodeChild.state.opened=true;
            nodeChild.children = [];
            nodeChild.icon = "jstree-file";
            jstree.core.data.push(nodeChild);

            zd.fillTree(spaceTree.root.childs[i],nodeChild,level);
        }


        jzq('#ztree').bind("ready.jstree", function () {
            if(zd.mode == 'free'){
                for(pageId in $rootScope["ztree"].spaceArticles){
                    zd.inlineDialog(pageId);
                }
            }
        });

        jzq('#ztree').bind("open_node.jstree", function (e,data) {
            if(zd.mode == 'free'){
                for(var i = 0;i<data.node.children_d.length;i++){
                    var pageId = data.node.children_d[i];
                    zd.inlineDialog(pageId);
                }
            }
        });

        jzq('#ztree').bind("select_node.jstree", function (e,data) {
            if(zd.mode != 'free'){
                zd.assignDescendants();
            }
        });


        jzq("#ztree").jstree(jstree);
    };
    zd.clear = function(){
        cTreeRemoteService.clearAllSelection();
    };
    zd.free.initDialog= function(selectedNodes){
        zd.free.showError = false;
        zd.free.showWarning = false;
        zd.free.showloader = true;
        zd.free.dialogInitiated = true;
        zd.free.showMainForm = false;
        zd.free.showWait = false;
        zd.free.updateButtonDisabled = true;

        zd.loadCategoriesAndSections(zd.free,selectedNodes);

    };
    zd.validateNodeSelections=function(model,selectedNodes){
        model.showWarning = false;
        if(selectedNodes!=null){
            for(var i = 0;i<selectedNodes.length;i++){
                if(selectedNodes[i].zPageNodeInfo.published){
                    model.showWarning = true;
                    model.warningMessage = "Category/Section will be updated only on confluence page metada. You will need to publish in order to apply this change into Zendesk.";
                    break;
                }
            }
        }
    }
    zd.loadCategoriesAndSections=function(model,selectedNodes,preselectedValue){
        if(model.data && model.data.lstCategories){
            cTreeRemoteService.deferred().then(function(){
                if(zd.mode=='free'){
                    zd.validateNodeSelections(model,selectedNodes);
                }

                model.showMainForm = true;
                model.updateButtonDisabled = false;
                if(!model.data.category && model.data.lstCategories.length>0){
                    model.data.category = model.data.lstCategories[0];
                }
                if(preselectedValue){
                    for(var i =0;i<model.data.lstCategories.length;i++){
                        if(model.data.lstCategories[i].id==preselectedValue){
                            model.data.category = model.data.lstCategories[i];
                            break;
                        }
                    }
                }
                zd.categoryChanged(model,selectedNodes);
            }).finally(function(){
                model.showloader = false;
            });
            return;
        }
        cTreeRemoteService.getCategories(zd.space).then(function(result){
            window.console.log('getCategories',result);
            if(zd.mode=='free'){
                zd.validateNodeSelections(model,selectedNodes);
            }
            model.showMainForm = true;
            model.data = {};
            model.data.lstCategories = result;
            model.updateButtonDisabled = false;
            if(!model.data.category && model.data.lstCategories.length>0){
                model.data.category = model.data.lstCategories[0];
            }
            if(preselectedValue){
                for(var i =0;i<model.data.lstCategories.length;i++){
                    if(model.data.lstCategories[i].id==preselectedValue){
                        model.data.category = model.data.lstCategories[i];
                        break;
                    }
                }
            }
            zd.categoryChanged(model,selectedNodes);
        }).catch(function(response){
            window.console.log('getCategories error',response);
            model.showError = true;
            zd.free.showWarning = false;

            if(response.data && response.data.message){
                model.errorMessage = response.data.message;
            }else if(response.statusText){
                model.errorMessage  = response.statusText;
            }else{
                model.errorMessage = 'Unknown Error';
            }
        }).finally(function(){
            model.showloader = false;
        });
    };
    zd.selectAll=function(){
        jzq("#ztree").jstree().select_all();

        for(pageId in $rootScope["ztree"].spaceArticles){
            zd.inlineDialog(pageId);
        }
    }
    zd.categoryChanged = function(model,selectedNodes){
        if(zd.mode=='descendants'){
            if(!zd.descendants.hasLevel2){
                return;
            }
        }
        model.disabledSection = true;
        cTreeRemoteService.getSections(model.data.category.id).then(function(result){
            window.console.log('sections',result);
            model.data.lstSections = result.lstSections;
            if(model.data.lstSections.length>0){
                model.data.section = model.data.lstSections[0];
            }
            if(zd.mode=='descendants' && selectedNodes){
                for(var i = 0 ;i<model.data.lstSections.length;i++){
                    if(selectedNodes[0].zPageNodeInfo.sectionId==model.data.lstSections[i].id){
                        model.data.section = model.data.lstSections[i];
                    }
                }
            }
        }).catch(function(response){
            window.console.log('sections error',response);
            model.showMainForm= false;
            model.showError = true;
            zd.free.showWarning = false;

            if(response.data && response.data.message){
                model.errorMessage =response.data.message;
            }else if(response.statusText){
                model.errorMessage  = response.statusText;
            }else{
                model.errorMessage = 'Unknown Error';
            }

        }).finally(function(){
            model.disabledSection = false;
        });
    }
    zd.free.closeDialog = function(){
        AJS.dialog2("#categorySectionDialog").hide();
    };

    zd.free.closeConfirmationDialog = function(){
        AJS.dialog2("#confirmationRemoveDialog").hide();
    };
    zd.descendants.closeDialog = function(){
        AJS.dialog2("#descendantsSectionDialog").hide();
    };
    zd.updateSelections = function(){
        zd.error = false;
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        if(selectedNodes.length==0){
            zd.error = true;
            zd.errorMessage = 'Please select at least one page';
            return;
        }
        zd.free.hint = "";
        if(!zd.free.dialogInitiated){
            zd.free.initDialog(selectedNodes);
        }else{
            zd.validateNodeSelections(zd.free,selectedNodes);
        }
        AJS.dialog2("#categorySectionDialog").show();
    };
    zd.removeSelections = function(){
        zd.error = false;
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        if(selectedNodes.length==0){
            zd.error = true;
            zd.errorMessage = 'Please select at least one page.';
            return;
        }
        var allBlank = true;
        for(var i = 0;i<selectedNodes.length;i++){
            allBlank = allBlank && (selectedNodes[i].zPageNodeInfo.sectionId==null);
            if(!allBlank){
                break;
            }
        }
        if(allBlank){
            zd.error = true;
            zd.errorMessage = 'The selected pages do not have Category/Section assigned.';
            return;
        }

        zd.free.hint = "";

        zd.free.showError = false;
        zd.free.showWarning = false;
        zd.free.showloader = false;
        zd.free.showMainForm = true;
        zd.free.showWait = false;
        zd.free.confirmRemoveDisabled = false;

        zd.free.showWarning = false;
        for(var i = 0;i<selectedNodes.length;i++){
            if(selectedNodes[i].zPageNodeInfo.published){
                zd.free.showWarning = true;
                zd.free.warningMessage = "Category/Section will be removed only on confluence page metada, "+
                    " published pages will remain published on Zendesk";
                break;
            }
        }
        AJS.dialog2("#confirmationRemoveDialog").show();
    };
    zd.validateSectionInput=function(model){
        model.categoryError = "";
        model.sectionError = "";
        var inputError = false;
        if(!model.data.category){
            inputError = true;
            model.categoryError = "You must select a category to publish";
        }
        if(!model.data.section){
            inputError = true;
            model.sectionError = "You must select a section to publish";
        }
        return inputError;
    };
    zd.free.confirmRemove=function(){
        var selectedPageIds = cTreeRemoteService.getSelectedPageIds();

        zd.free.showWait = true;
        zd.free.updateButtonDisabled = true;

        cTreeRemoteService.removeSectionToPages(selectedPageIds).then(function(result){
            window.console.log('removeSectionToPages',result);
            zd.free.hint = "Success!";
            zd.free.updateButtonDisabled = false;
            window.setTimeout(
                function(){
                    AJS.dialog2("#confirmationRemoveDialog").hide();
                    zd.renderTree();
                },1000);
        }).catch(function(response){
            window.console.log('removeSectionToPages error',response);
            zd.free.showMainForm= false;
            zd.free.showError = true;
            zd.free.showWarning = false;

            if(response.data && response.data.message){
                zd.free.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.free.errorMessage  = response.statusText;
            }else{
                zd.free.errorMessage = 'Unknown Error';
            }
        }).finally(function(){
            zd.free.showWait = false;
        });
    };
    zd.free.stablish=function(){
        if(zd.validateSectionInput(zd.free)){
            return;
        }
        var selectedPageIds = cTreeRemoteService.getSelectedPageIds();

        zd.free.showWait = true;
        zd.free.updateButtonDisabled = true;

        cTreeRemoteService.stablishSectionToPages(zd.free.data.section.id,selectedPageIds).then(function(result){
            window.console.log('stablishSectionToPages',result);
            zd.free.hint = "Success!";
            zd.free.updateButtonDisabled = false;
            window.setTimeout(
                function(){
                    AJS.dialog2("#categorySectionDialog").hide();
                    zd.renderTree();
                },1000);
        }).catch(function(response){
            window.console.log('stablishSectionToPages error',response);
            zd.free.showMainForm= false;
            zd.free.showError = true;
            zd.free.showWarning = false;

            if(response.data && response.data.message){
                zd.free.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.free.errorMessage  = response.statusText;
            }else{
                zd.free.errorMessage = 'Unknown Error';
            }
        }).finally(function(){
            zd.free.showWait = false;
        });
    };
    zd.descendants.stablishContinue=function(){
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        selectedNodes[0].zPageNodeInfo.categoryId = zd.descendants.data.category.id;
        selectedNodes[0].zPageNodeInfo.sectionId = null;
        for(var i=0;i<selectedNodes[0].childs.length;i++){
            selectedNodes[0].childs[i].zPageNodeInfo.categoryId = null;
            if(selectedNodes[0].childs[i].zPageNodeInfo.sectionId!=null){
                selectedNodes[0].childs[i].zPageNodeInfo.sectionId = null;

                jzq('#link_'+selectedNodes[0].childs[i].pageId).html(
                    '<a>'+selectedNodes[0].childs[i].pageTitle+'</a>');

            }
        }
        AJS.dialog2("#descendantsSectionDialog").hide();
    };
    zd.descendants.stablish=function(){
        zd.descendants.sectionError="";
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        if(selectedNodes[0].level==1){
            if(!zd.descendants.data.category){
                zd.descendants.categoryError="Please select a category";
                return;
            }
            if(zd.descendants.selectedNode.zPageNodeInfo.categoryId!=null &&
                zd.descendants.selectedNode.zPageNodeInfo.categoryId!=zd.descendants.data.category.id){
                var oneWithSection =false;
                for(var i=0;i<zd.descendants.selectedNode.childs.length;i++){
                    if(zd.descendants.selectedNode.childs[i].zPageNodeInfo.sectionId!=null){
                        oneWithSection =true;
                        break;
                    }
                }
                if(oneWithSection){
                    zd.descendants.showContinue=true;
                    zd.descendants.showUpdate=false;
                    zd.descendants.showRemove=false;

                    zd.descendants.showWarning = true;
                    zd.descendants.warningMessage = 'By Changing the category you will remove'+
                        ' assigned sections for child pages, Do you want to continue?';

                    zd.descendants.showMainForm = false;
                    return;
                }
            }
            selectedNodes[0].zPageNodeInfo.categoryId = zd.descendants.data.category.id;
            selectedNodes[0].zPageNodeInfo.sectionId = null;
        }else if(selectedNodes[0].level==2){
            if(!zd.descendants.data.section){
                zd.descendants.sectionError="Please select a section";
                return;
            }
            selectedNodes[0].zPageNodeInfo.sectionId = zd.descendants.data.section.id;
            selectedNodes[0].zPageNodeInfo.categoryId = null;
        }
        jzq('#link_'+selectedNodes[0].pageId).html(
            '<span class="aui-icon aui-icon-small aui-iconfont-edit-small" title="Zendesk Category/Section stablished"></span>&nbsp;'+
            '<a>'+selectedNodes[0].pageTitle+'</a>');
        AJS.dialog2("#descendantsSectionDialog").hide();
    };

    zd.descendants.removeContinue=function(){
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        selectedNodes[0].zPageNodeInfo.categoryId = null;

        for(var i=0;i<selectedNodes[0].childs.length;i++){
            if(selectedNodes[0].childs[i].zPageNodeInfo.sectionId!=null){
                selectedNodes[0].childs[i].zPageNodeInfo.sectionId = null;

                jzq('#link_'+selectedNodes[0].childs[i].pageId).html(
                    '<a>'+selectedNodes[0].childs[i].pageTitle+'</a>');

            }
        }
        jzq('#link_'+selectedNodes[0].pageId).html(
            '<a>'+selectedNodes[0].pageTitle+'</a>');
        AJS.dialog2("#descendantsSectionDialog").hide();
    };
    zd.descendants.remove=function(){
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        if(selectedNodes[0].level==1){
            var oneWithSection =false;
            for(var i=0;i<zd.descendants.selectedNode.childs.length;i++){
                if(zd.descendants.selectedNode.childs[i].zPageNodeInfo.sectionId!=null){
                    oneWithSection =true;
                    break;
                }
            }
            if(oneWithSection){
                zd.descendants.showRemoveContinue=true;
                zd.descendants.showUpdate=false;
                zd.descendants.showRemove=false;

                zd.descendants.showWarning = true;
                zd.descendants.warningMessage = 'By Removing the Category you will remove'+
                    ' assigned Sections for child pages, Do you want to continue?';

                zd.descendants.showMainForm = false;
                return;
            }
            selectedNodes[0].zPageNodeInfo.categoryId = null;
        }else if(selectedNodes[0].level==2){
            selectedNodes[0].zPageNodeInfo.sectionId = null;
        }
        jzq('#link_'+selectedNodes[0].pageId).html(
            '<a>'+selectedNodes[0].pageTitle+'</a>');
        AJS.dialog2("#descendantsSectionDialog").hide();
    };


    zd.assignDescendants=function(){
        zd.error = false;
        var selectedNodes = cTreeRemoteService.getSelectedNodes();
        window.console.log('selectedNodes',selectedNodes);
        if(selectedNodes.length==0){
            zd.error = true;
            zd.errorMessage = 'Please select at least one page';
        }else{
            zd.descendants.selectedNode = selectedNodes[0];
            zd.descendants.hasLevel1 = (selectedNodes[0].level==1);
            zd.descendants.hasLevel2 = (selectedNodes[0].level==2);

            cTreeRemoteService.deferred().then(function(result){
                if(zd.descendants.data && zd.descendants.data.lstSections){
                    zd.descendants.data.lstSections = [];
                }
                zd.descendants.hint = "";

                zd.descendants.showRemove = false;
                zd.descendants.showContinue = false;
                zd.descendants.showRemoveContinue = false;
                zd.descendants.showUpdate = true;
                zd.descendants.showError = false;
                zd.descendants.showWarning = false;
                zd.descendants.showloader = true;
                zd.descendants.dialogInitiated = true;
                zd.descendants.showMainForm = false;
                zd.descendants.showWait = false;
                zd.descendants.updateButtonDisabled = true;
                zd.descendants.removeButtonDisabled = false;

                var categoryId = null;
                if(zd.descendants.hasLevel2){
                    if(zd.descendants.selectedNode.zPageNodeInfo.sectionId !=null){
                        zd.descendants.showRemove = true;
                    }
                    if(zd.descendants.selectedNode.parent!=null){
                        categoryId = zd.descendants.selectedNode.parent.zPageNodeInfo.categoryId;
                        if(categoryId==null){
                            zd.descendants.showWarning = true;
                            zd.descendants.warningMessage = 'Please assign a Category for the parent page';

                            zd.descendants.showloader = false;
                        }else{
                            zd.loadCategoriesAndSections(zd.descendants,selectedNodes,categoryId);
                        }
                    }
                }else{
                    if(zd.descendants.selectedNode.zPageNodeInfo.categoryId!=null){
                        zd.descendants.showRemove = true;
                    }
                    categoryId = zd.descendants.selectedNode.zPageNodeInfo.categoryId;
                    zd.loadCategoriesAndSections(zd.descendants,selectedNodes,categoryId);
                }

                AJS.dialog2("#descendantsSectionDialog").show();

            }).finally(function(){
            });
        }
    };
    zd.saveDescendants=function(){
        zd.error = false;
        zd.success = false;

        var request = [];
        for(var pageId in $rootScope["ztree"].spaceArticles){
            request.push({
                pageId:pageId,
                categoryId:$rootScope["ztree"].spaceArticles[pageId].zPageNodeInfo.categoryId,
                sectionId:$rootScope["ztree"].spaceArticles[pageId].zPageNodeInfo.sectionId
            });
        }

        zd.showWait = true;
        zd.saveDescendantsDisabled = true;

        cTreeRemoteService.assignDescendants(request).then(function(result){
            window.console.log('assignDescendants',result);
            zd.success = true;
            zd.successMessage = 'Metadata saved successfully';
        }).catch(function(response){
            window.console.log('assignDescendants error',response);

            zd.error = true;
            if(response.data && response.data.message){
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }

        }).finally(function(){
            zd.showWait = false;
            zd.saveDescendantsDisabled = false;
        });
    };
};
var cTreeRemoteService = function($rootScope,$q,$http) {
    return {
        deferred:function(){
            var deferred = $q.defer();
            deferred.resolve();
            return deferred.promise;
        },
        clearAllSelection:function(){
            jzq("#ztree").jstree().deselect_all();
        },
        renderTree:function(spaceKey,mode){
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/tree/ZENDESK?spaceKey="+spaceKey+"&mode="+mode,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                var result = response.data;
                deferred.resolve(result);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getCategoryDescription:function(sectionId){
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/category-description?sectionId="+sectionId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                var result = response.data;
                deferred.resolve(result);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getSelectedNodes:function(){
            selectionIds = jzq("#ztree").jstree().get_selected();
            var selectedNodes = [];
            for(var i = 0 ; i<selectionIds.length; i++){
                var pageId = selectionIds[i];
                selectedNodes.push($rootScope["ztree"].spaceArticles[pageId]);
            }
            return selectedNodes;
        },
        getSelectedPageIds:function(){
            return jzq("#ztree").jstree().get_selected();;
        },
        getSections: function(categoryId) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/sections/"+categoryId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getCategories: function() {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/categories",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        removeSectionToPages:function(pageIds){
            var deferred = $q.defer();
            var req = {
                method: "PUT",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/remove-section-bulk",
                headers: {
                    'Content-Type': "application/json"
                },
                data:pageIds
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        stablishSectionToPages:function(sectionId,pageIds){
            var deferred = $q.defer();
            var req = {
                method: "PUT",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/stablish-section-bulk?sectionId="+
                    sectionId,
                headers: {
                    'Content-Type': "application/json"
                },
                data:pageIds
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        assignDescendants:function(request){
            var deferred = $q.defer();
            var req = {
                method: "PUT",
                url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/stablish-section-descendants",
                headers: {
                    'Content-Type': "application/json"
                },
                data:request
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        refreshTree:function(){
            $rootScope["ztree"].controller.refresh();
        },
        reRender:function(mode){
            $rootScope["ztree"].controller.reRender(mode);
        }
    };
};

var zApp = window.zkbangular.module("src", []);
zApp.factory("cTreeRemoteService",cTreeRemoteService);
cTreeRemoteService.$inject = ["$rootScope","$q","$http"];

zApp.component("ztree",{
    bindings: {
        space: '@',
        mode: '@'
    },
    templateUrl: AJS.Data.get("context-path") +
        '/download/resources/com.zagile.confluence.kb.knowledge-bridge:angular-templates/zendesk-confluence-page-tree.html',
    controller: ['$rootScope', '$scope', 'cTreeRemoteService', ZConfluenceTree],
});