AJS.toInit(function(){
	AJS.$('#zendeskDeleteDialogWI').click(function(e){
		e.preventDefault(); 
		if(AJS.$("#zendeskDeleteDialog").length==0){
			initDeleteDialog();
		}else{
			AJS.dialog2("#zendeskDeleteDialog").show();
		}
	});
});

var ZendeskDelete=function($scope,zDeleteDataService){
	var zd = this;
	zd.isShowing = {
			wait:false,
			mainForm:false,
			loader: true
	};
	zd.error = false;
	zd.data = {};
	zd.contextPath = AJS.contextPath();
	zd.waitIconUrl = zd.contextPath+'/images/icons/wait.gif';
	zd.deleteDisabled = true;
	zDeleteDataService.editMeta().then(function(result){
		window.console.log('edit meta',result);
		zd.deleteDisabled =false;
		zd.data = result;
		if(zd.data.translations.length==0){
			zd.error = true;
			zd.errorMessage = "Error, no publications found";
		}else{
			zd.isShowing.publishedPage = true;
			zd.isShowing.mainForm = true;
			zd.deleteDisabled = false;
		}
	}).catch(function(response){
		window.console.log('edit meta error',response);
		zd.error = true;
		if(response.data && response.data.message){
			zd.errorMessage = response.data.message;
		}else if(response.statusText){
            zd.errorMessage =  response.statusText;
        }else{
            zd.errorMessage = 'Unknown Error';
        }
	}).finally(function(){
		zd.isShowing.loader = false;
	});
	AJS.dialog2("#zendeskDeleteDialog").show();
	//-------------
	zd.closeDialog=function(){
		AJS.dialog2("#zendeskDeleteDialog").hide();
	};
	zd.formatDate=function(longDate){
		var date = new Date(longDate);
		return date.toLocaleString();
	};
	zd.deleteArticle=function(){
		zd.deleteDisabled =true;
		zd.isShowing.wait= true;
		zDeleteDataService.deletePublication().then(function(result){
			window.console.log('deletePublication',result);
			location.reload();
		}).catch(function(response){
			window.console.log('deletePublication error',response);
			zd.error = true;
			if(response.data && response.data.message){
				zd.errorMessage = response.data.message;
			}else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
		}).finally(function(){
			zd.isShowing.wait= false;
		});
	}
}
var zDeleteDataService = function($q,$http) {
	return{
		editMeta: function() {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/page-editmeta/ZENDESK/"+
					AJS.params.pageId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		deletePublication: function() {
			var deferred = $q.defer();
			var req = {
					method: "DELETE",
					url: AJS.contextPath()+
						"/rest/kb-internal/1.0/publish/delete-publication/ZENDESK?pageId="+AJS.params.pageId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		}
	};
}  

function initDeleteDialog(){
	//--inject dialog with angular component to body
	var dialog2Str = '';
	dialog2Str += '<section role="dialog" id="zendeskDeleteDialog" class="aui-layer aui-dialog2 aui-dialog2-medium" aria-hidden="true">';
	dialog2Str += '<div ng-app="zd-dlt-src">';
	dialog2Str += '<zendesk-delete>';
	dialog2Str += '</zendesk-delete>';
	dialog2Str += '</div>';
	dialog2Str += '</section>';
	AJS.$(document.body).append(AJS.$(dialog2Str));

	//--create angular app, initiate component and relate controller and services
	var zendeskUpdate = window.zkbangular.module("zd-dlt-src", []);
	zendeskUpdate.factory("zDeleteDataService", zDeleteDataService);
	zDeleteDataService.$inject = ["$q", "$http"];

	zendeskUpdate.component("zendeskDelete", {
		templateUrl: AJS.Data.get("context-path") +
			'/download/resources/com.zagile.confluence.kb.knowledge-bridge:angular-templates/zendesk-delete-article.html',
		controller: ['$scope', 'zDeleteDataService', ZendeskDelete]
	});

	//--compile angular app
	var injector = window.zkbangular.injector(["ng", "zd-dlt-src"]);
	injector.invoke(function ($compile, $rootScope) {
		$compile(AJS.$("div[ng-app='zd-dlt-src']"))($rootScope);
		$rootScope.$apply();
	});
}