var zContextIsMove = false;
function initInternal(e){
	e.preventDefault(); 
	if(AJS.$("#zMoveStablishDialog").length==0){
		initMoveStablishDialog();
	}else{
		AJS.dialog2("#zMoveStablishDialog").show();
	}
}
AJS.toInit(function(){
	AJS.$('#zMoveSectionWebItem').click(function(e){
		zContextIsMove = true;
		initInternal(e);
	});
	AJS.$('#zStablishSectionWebItem').click(function(e){
		zContextIsMove = false;
		initInternal(e);
	});
	
});
var ZMoveStablishController=function($scope,moveStablishService){
	var zd = this;
	zd.waitIconUrl = AJS.contextPath()+'/images/icons/wait.gif';
	if(zContextIsMove){
		zd.title = "Move Zendesk Article";
		zd.moveStablishButtonLabel = "Move";
	}else{
		zd.title = "Assign Zendesk Article";
		zd.moveStablishButtonLabel = "Assign";
	}
	AJS.dialog2("#zMoveStablishDialog").show();
	
	zd.showloader = true;
	zd.showWait = false;
	zd.showError = false;
	zd.moveStablishButtonShow = true;
	zd.moveStablishButtonDisabled = false;
	moveStablishService.createMeta().then(function(result){
		window.console.log('create meta',result);
		if(result.category !=null){
			result.category = {id:result.category};
		}
		if(result.section !=null){
			result.section = {id:result.section};
		}
		if(zContextIsMove && result.section==null && result.category ==null){
			zd.title = "Assign Zendesk Article";
			zd.moveStablishButtonLabel = "Assign";
		}
		zd.data = result;
		zd.showMainForm = true;
		zd.publishUpdateDisabled =false;
		if(!zd.data.category && zd.data.lstCategories.length>0){
			zd.data.category = zd.data.lstCategories[0];
		}
		zd.categoryChanged();
	}).catch(function(response){
		window.console.log('create meta error',response);
		zd.error = true;

		if(response.data && response.data.message){
			zd.errorMessage = response.data.message;
		}else if(response.statusText){
            zd.errorMessage =  response.statusText;
        }else{
            zd.errorMessage = 'Unknown Error';
        }
	}).finally(function(){
		zd.showloader = false;
	});
	//--
	zd.categoryChanged=function(){
		zd.disabledSection = true;
		moveStablishService.getSections(zd.data.category.id).then(function(result){
			window.console.log('sections',result);
			zd.data.lstSections = result.lstSections;
			if(!zd.data.section && zd.data.lstSections.length>0){
				zd.data.section = zd.data.lstSections[0];
			}
		}).catch(function(response){
			window.console.log('section error',response);
			zd.isShowing.mainForm = false;
			zd.error = true;

			if(response.data && response.data.message){
				zd.errorMessage = response.data.message;
			}else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }

		}).finally(function(){
			zd.disabledSection = false;
		});
	};
	zd.moveStablish= function(){
		zd.categoryError = "";
		zd.sectionError = "";

		var inputError = false;
		if(!zd.data.category){
			inputError = true;
			zd.categoryError = "You must select a category to publish";
		}
		if(!zd.data.section){
			inputError = true;
			zd.sectionError = "You must select a section to publish";
		}
		if (inputError){
			return;
		}
		
		zd.showWait = true;
		zd.moveStablishButtonDisabled = true;
		zd.hintStyle={"color":"black"};
		zd.hint = "";
		var request ={
				pageId:AJS.params.pageId,
				categoryId:zd.data.category.id,
				sectionId:zd.data.section.id,
				articleId: zd.data.articleId
		};
		moveStablishService.moveStablish(request).then(function(result){
			window.console.log('moveStablish',result);
			if(result.error){
				zd.hintStyle={"color":"red"};
				zd.hint = result.errorMessage;
			}else{
				zd.hint = "Section updated Succesfully!";
			}			
		}).catch(function(response){
			window.console.log('moveStablish error',response);
			zd.hintStyle={"color":"red"};

			if(response.data && response.data.message){
				zd.hint = response.data.message;
			}else if(response.statusText){
                zd.hint =  response.statusText;
            }else{
                zd.hint = 'Unknown Error';
            }
		}).finally(function(){
			zd.showWait = false;
			zd.moveStablishButtonDisabled = false;
		});
	};
	zd.closeDialog=function(){
		AJS.dialog2("#zMoveStablishDialog").hide();
	};
};
var moveStablishService = function($q,$http) {
	return {
		createMeta: function() {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/page-createmeta/ZENDESK/"+
					AJS.params.pageId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		getSections: function(categoryId) {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/sections/"+categoryId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		moveStablish: function(request) {
			var deferred = $q.defer();
			var req = {
					method: "PUT",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/move-or-stablish-section/",
					headers: {
						'Content-Type': "application/json"
					},
					data:request
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		}
	};
};
function initMoveStablishDialog(){
	//--inject dialog with angular component to body
	var dialog2Str = '';
	dialog2Str += '<section role="dialog" id="zMoveStablishDialog" class="aui-layer aui-dialog2 aui-dialog2-medium" aria-hidden="true">';
	dialog2Str += '<div ng-app="zmove-stablish-src">';
	dialog2Str += '<zmove>';
	dialog2Str += '</zmove>';
	dialog2Str += '</div>';
	dialog2Str += '</section>';
	AJS.$(document.body).append(AJS.$(dialog2Str));

	//--create angular app, initiate component and relate controller and services
	var zMoveStablish = window.zkbangular.module("zmove-stablish-src", []);
	zMoveStablish.factory("moveStablishService", moveStablishService);
	moveStablishService.$inject = ["$q", "$http"];

	zMoveStablish.component("zmove", {
		templateUrl: AJS.Data.get("context-path") +
			'/download/resources/com.zagile.confluence.kb.knowledge-bridge:angular-templates/zendesk-move-or-stablish-section.html',
		controller: ['$scope', 'moveStablishService', ZMoveStablishController]
	});

	//--compile angular app
	var injector = window.zkbangular.injector(["ng", "zmove-stablish-src"]);
	injector.invoke(function ($compile, $rootScope) {
		$compile(AJS.$("div[ng-app='zmove-stablish-src']"))($rootScope);
		$rootScope.$apply();
	});
}