AJS.toInit(function(){
	AJS.$('#zendeskUpdateDialog, #zendeskUpdateDialogBtn').click(function(e){
		e.preventDefault(); 
		if(AJS.$("#zdPublishUpdateDialog").length==0){
			initPublishUpdateDialog(false);
		}else{
			restartDialogIfNeeded();
			
		}
	});
	AJS.$('#zendeskPublishDialog, #zendeskPublishDialogBtn').click(function(e){
		e.preventDefault(); 
		if(AJS.$("#zdPublishUpdateDialog").length==0){
			initPublishUpdateDialog(true);
		}else{
			restartDialogIfNeeded();
		}
	});
});
function restartDialogIfNeeded(){
	if(zAgileIsPublishContext && zAgileIsLabelsContext && zAgileInputStage && zAgilePublishControllerReference!=null){
		zAgilePublishControllerReference.internalInit();
	}else if(!zAgileIsPublishContext && zAgileUpdateSectionNull){
		zAgilePublishControllerReference.internalInit();
	}
	AJS.dialog2("#zdPublishUpdateDialog").show();
}
var zAgileIsPublishContext;
var zAgileIsLabelsContext = false;
var zAgileInputStage = true;
var zAgilePublishControllerReference = null;
var zAgileUpdateSectionNull = false;
var ZendeskPublishUpdate=function($scope,zdDataService){
	var zd = this;
	zAgilePublishControllerReference = zd;
	zd.internalInit=function(){
		zd.maxEntries = 5;
		zd.isPublish = zAgileIsPublishContext;
		zd.title = zd.isPublish? "Publish to Zendesk":"Update in Zendesk";
		zd.hint = '';
		zd.publishUpdateButtonLabel =zd.isPublish? 'Publish':'Update';
		zd.contextPath = AJS.contextPath();
		zd.waitIconUrl = zd.contextPath+'/images/icons/wait.gif';
		zd.isShowing = {
				wait:false,
				mainForm:false,
				loader: true,
				publishedPage: false,
				resultPage: false
		};
		zd.error = false;
		zd.warning = false;
		zd.publishUpdateDisabled =true;
		zd.publishMakePublishButton = false;
		zd.publishMakePublishButtonDisabled = true;
		zd.publishUpdateShow = true;
		zd.data = {};
		AJS.dialog2("#zdPublishUpdateDialog").show();
		if(zd.isPublish){
			zd.draft = true;
			zdDataService.createMeta().then(function(result){
				window.console.log('create meta',result);
				zAgileIsLabelsContext = (result.mode=='labels');
				
				if(result.mode=='descendants' && result.descendantsCategorySectionPage){
					zd.warning = true;
					zd.warningMessage = 'The page represents a Zendesk category/section and can not be published.';
					return;
				}
				
				if(result.mode=='descendants' && result.category==null && result.section == null){
					zd.warning = true;
					zd.warningMessage = 'The page could not get a Zendesk category/section from his ancestors.';
					return;
				}
				
				if(result.mode=='labels' && result.section == null){
					zd.warning = true;
					zd.warningMessage = 'The page could not get a Zendesk category/section from his labels'+
						' change labels mapping and try again';
					return;
				}
				
				if(result.category !=null){
					result.category = {id:result.category};
				}
				if(result.section !=null){
					result.section = {id:result.section};
				}
				zd.data = result;
				zd.isShowing.mainForm = true;
				zd.publishUpdateDisabled =false;
				if(!zd.data.category && zd.data.lstCategories.length>0){
					zd.data.category = zd.data.lstCategories[0];
				}
				zd.categoryChanged();
			}).catch(function(response){
				window.console.log('create meta error',response);
				zd.error = true;
				if(response.data && response.data.message){
					zd.errorMessage = response.data.message;
				}else if(response.statusText){
                    zd.errorMessage =  response.statusText;
                }else{
                    zd.errorMessage = 'Unknown Error';
                }
			}).finally(function(){
				zd.isShowing.loader = false;
			});
		}
		else{
			zdDataService.editMeta().then(function(result){
				window.console.log('edit meta',result);
				zd.data = result;
				
				if(result.sectionId == null){
					zd.error = true;
					zAgileUpdateSectionNull = true;
					if(result.mode=="free"){
						zd.errorMessage = "Zendesk assigned section has been removed, you cannot publish this page until you re-assign one.";
					}else if(result.mode=="descendants"){
						zd.errorMessage = "Page can not resolve Zendesk section from his ancestors";
					}else if(result.mode=="labels"){
						zd.errorMessage = "Page can not resolve Zendesk section from labels";
					}
					return;
				}
				
				if(zd.data.translations.length==0){
					zd.error = true;
					zd.errorMessage = "Error, no publications found";
				}else{
					zd.publishUpdateDisabled =false;
					zd.isShowing.publishedPage = true;
					zd.isShowing.mainForm = true;
				}
			}).catch(function(response){
				window.console.log('edit meta error',response);
				zd.error = true;

				if(response.data && response.data.message){
					zd.errorMessage = response.data.message;
				}else if(response.statusText){
                    zd.errorMessage =  response.statusText;
                }else{
                    zd.errorMessage = 'Unknown Error';
                }
			}).finally(function(){
				zd.isShowing.loader = false;
			});
		}
	}
	zd.internalInit();
	//-------------
	zd.closeDialog=function(){
		AJS.dialog2("#zdPublishUpdateDialog").hide();
	};
	zd.formatDate=function(longDate){
		var date = new Date(longDate);
		return date.toLocaleString();
	};
	zd.upgradePageConfirmation=function(request){
		zd.validationForm = false;
		zd.isShowing.mainForm = true;
		zd.publishUpdateButtonLabel = 'Update';

		zd.publishUpdateDisabled = true;
		zd.isShowing.wait = true;
		zd.isShowing.publishedPage = false;
		zdDataService.update(request).then(function(result){
			window.console.log('update',result);
			zd.monitoringId=result.monitoringId;

			zd.monitorPublishing();
		}).catch(function(response){
			window.console.log('update error',response);
			zd.isShowing.mainForm = false;
			zd.error = true;
			zd.isShowing.wait = false;

			if(response.data && response.data.message){
				zd.errorMessage = response.data.message;
			}else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
		}).finally(function(){

		});
	};
	zd.upgradePage=function(){
		var request ={
				pageId:AJS.params.pageId,
				pageVersion:zd.data.pageVersion,
				sectionId: zd.data.sectionId==null?0:zd.data.sectionId,
				translations:[
					{
						locale:zd.data.translations[0].locale,
						draft:zd.data.translations[0].draft
					}
				]
		};
		if(zd.publishUpdateButtonLabel == 'Continue'){
			zd.upgradePageConfirmation(request);
			return;
		}
		zd.validateInternal(request,zd.upgradePageConfirmation);
		
	};
	zd.validateInternal = function(request,callback){
		zd.publishUpdateDisabled = true;
		zd.isShowing.wait = true;
		zd.isShowing.publishedPage = false;
		zdDataService.validate(request).then(function(result){
			window.console.log('validate',result);
			var maxResults = 3;
			var brokenLinks = 0;
			zd.validation = {pageLinks:[]};
			for(var i = 0 ; i<result.pageLinks.length;i++){
				if(result.pageLinks[i].articleId==0){
					result.pageLinks[i].hidden = (i>=maxResults);
					zd.validation.pageLinks.push(result.pageLinks[i]);
					brokenLinks++;
				}
			}
			zd.hiddenItems = brokenLinks-maxResults;
			if(brokenLinks>0){
				zd.validationForm = true;
				zd.publishUpdateButtonLabel = 'Continue';
				zd.isShowing.mainForm = false;

				zd.publishUpdateDisabled = false;
				zd.isShowing.wait = false;
			}else{
				callback(request);
			}
		}).catch(function(response){
			window.console.log('validate error',response);
			zd.isShowing.mainForm = false;
			zd.error = true;
			zd.isShowing.wait = false;

			if(response.data && response.data.message){
				zd.errorMessage = response.data.message;
			}else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }

			zd.publishUpdateButtonLabel = 'Continue';

			zd.publishUpdateDisabled = false;
			zd.isShowing.wait = false;
		}).finally(function(){

		});
	};
	zd.monitorPublishing=function(){
		zdDataService.monitor(zd.monitoringId).then(function(result){
			window.console.log('monitoring',result);
			if(result.status){
				zd.hint =result.status;
				setTimeout(function(){zd.monitorPublishing();},4000);
			}else{
				zd.summaryResults();
			}
		}).catch(function(response){
			window.console.log('monitoring error',response);

		}).finally(function(){

		});
	};
	zd.summaryResults=function(){
		zd.isShowing.wait = false;
		zd.hint = '';
		zdDataService.summaryResults().then(function(result){
			window.console.log('summaryResults',result);
			if(result.error){
				zd.hint = result.errorMessage;
				zd.hintStyle={"color":"red"};
			}else{
				zd.isShowing.resultPage = true;
				zd.resultUrl = result.translations[0].url;
				zd.publishUpdateResult = result;
				
				if(zd.isPublish && zd.draft){
					zd.publishMakePublishButton = true;
					zd.publishMakePublishButtonDisabled = false;
					zd.publishUpdateShow = false;
				}
			}
		}).catch(function(response){
			window.console.log('summaryResults error',response);

		}).finally(function(){

		});
	};
	zd.showAllLinks=function(){
		for(var i = 0 ; i<zd.validation.pageLinks.length;i++){
			zd.validation.pageLinks[i].hidden = false;
		}
		zd.hiddenItems=0;
	};
	zd.categoryChanged=function(){
		zd.disabledSection = true;
		zdDataService.getSections(zd.data.category.id).then(function(result){
			window.console.log('sections',result);
			zd.data.lstSections = result.lstSections;
			if(!zd.data.section && zd.data.lstSections.length>0){
				zd.data.section = zd.data.lstSections[0];
			}
		}).catch(function(response){
			window.console.log('sections error',response);
			zd.isShowing.mainForm = false;
			zd.error = true;

			if(response.data && response.data.message){
				zd.errorMessage = response.data.message;
			}else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }

		}).finally(function(){
			zd.disabledSection = false;
		});
	};
	zd.publishConfirmation=function(request){
		zAgileInputStage = false;
		
		zd.validationForm = false;
		zd.isShowing.mainForm = true;
		zd.publishUpdateButtonLabel = 'Publish';
		zd.publishUpdateDisabled = true;
		
		zd.publishDisabled = true;
		zd.disabledCategory=true;
		zd.disabledSection=true;
		zd.disabledDraft=true;
		zd.isShowing.wait = true;
		zdDataService.publish(request).then(function(result){
			window.console.log('publish',result);
			zd.monitoringId=result.monitoringId;
			zd.monitorPublishing();
		}).catch(function(response){
			window.console.log('publish error',response);
			zd.isShowing.mainForm = false;
			zd.error = true;
			zd.isShowing.wait = false;

			if(response.data && response.data.message){
				zd.errorMessage = response.data.message;
			}else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
		}).finally(function(){

		});
	};
	zd.publishPage=function(){
		zd.categoryError = "";
		zd.sectionError = "";

		var inputError = false;
		if(!zd.data.category){
			inputError = true;
			zd.categoryError = "You must select a category to publish";
		}
		if(!zd.data.section){
			inputError = true;
			zd.sectionError = "You must select a section to publish";
		}
		if (inputError){
			return;
		}
		var request ={
				pageId:AJS.params.pageId,
				categoryId:zd.data.category.id,
				sectionId:zd.data.section.id,
				translations:[
					{
						locale:zd.data.defaultLocale,
						draft:zd.draft
					}
				]
		};

		if(zd.publishUpdateButtonLabel == 'Continue'){
			zd.publishConfirmation(request);
			return;
		}
		zd.validateInternal(request,zd.publishConfirmation);
	};
	
	zd.publishUpdatePage=function(){
		if(zd.isPublish){
			zd.publishPage();
		}else{
			zd.upgradePage();
		}
	};
	zd.changeDraftFlag=function(draft){
		var articleId = zd.publishUpdateResult.articleId;
		var locale = zd.publishUpdateResult.translations[0].locale;
		zd.publishMakePublishButtonDisabled = true;
		zd.isShowing.wait = true;
		zdDataService.changeDraft(articleId,locale,draft).then(function(result){
			window.console.log('changeDraft',result);
		}).catch(function(response){
			window.console.log('changeDraft error',response);
			zd.isShowing.mainForm = false;
			zd.error = true;

			if(response.data && response.data.message){
				zd.errorMessage = response.data.message;
			}else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage = 'Unknown Error';
            }
		}).finally(function(){
			zd.isShowing.wait = false;
		});
	}
}
var zdDataService = function($q,$http) {
	return{
		changeDraft:function(articleId,locale,draft){
			var deferred = $q.defer();
			var req = {
					method: "PUT",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/change-draft-flag"+
						"?articleId="+articleId+"&draft="+draft+"&locale="+locale+"&pageId="+AJS.params.pageId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		createMeta: function() {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/page-createmeta/ZENDESK/"+
					AJS.params.pageId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		getSections: function(categoryId) {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/zendesk-utils/sections/"+categoryId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		publish: function(request) {
			var deferred = $q.defer();
			var req = {
					method: "PUT",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/publish/ZENDESK/",
					headers: {
						'Content-Type': "application/json"
					},
					data:request
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		editMeta: function() {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/page-editmeta/ZENDESK/"+
					AJS.params.pageId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		update: function(request) {
			var deferred = $q.defer();
			var req = {
					method: "PUT",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/update/ZENDESK/",
					headers: {
						'Content-Type': "application/json"
					},
					data:request
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		monitor: function(monitoringId) {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/status/"+monitoringId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		summaryResults: function() {
			var deferred = $q.defer();
			var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/summary/ZENDESK/"+AJS.params.pageId,
					headers: {
						'Content-Type': "application/json"
					}
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		},
		validate: function(request) {
			var deferred = $q.defer();
			var req = {
					method: "PUT",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/publish/validate/ZENDESK/",
					headers: {
						'Content-Type': "application/json"
					},
					data:request
			};
			$http(req).then(function success(response) {
				deferred.resolve(response.data);
			}, function error(data) {
				deferred.reject(data);
			});
			return deferred.promise; 
		}
	};            
}  

function initPublishUpdateDialog(ppublish){
	zAgileIsPublishContext = ppublish;
	//--inject dialog with angular component to body
	var dialog2Str = '';
	dialog2Str += '<section role="dialog" id="zdPublishUpdateDialog" class="aui-layer aui-dialog2 aui-dialog2-medium" aria-hidden="true">';
	dialog2Str += '<div ng-app="zd-upd-src">';
	dialog2Str += '<zendesk-publish-update>';
	dialog2Str += '</zendesk-publish-update>';
	dialog2Str += '</div>';
	dialog2Str += '</section>';
	AJS.$(document.body).append(AJS.$(dialog2Str));

	//--create angular app, initiate component and relate controller and services
	var zendeskUpdate = window.zkbangular.module("zd-upd-src", []);
	zendeskUpdate.factory("zdDataService", zdDataService);
	zdDataService.$inject = ["$q", "$http"];

	zendeskUpdate.component("zendeskPublishUpdate", {
		templateUrl: AJS.Data.get("context-path") +
			'/download/resources/com.zagile.confluence.kb.knowledge-bridge:angular-templates/zendesk-publish-or-update.html',
		controller: ['$scope', 'zdDataService', ZendeskPublishUpdate]
	});

	//--compile angular app
	var injector = window.zkbangular.injector(["ng", "zd-upd-src"]);
	injector.invoke(function ($compile, $rootScope) {
		$compile(AJS.$("div[ng-app='zd-upd-src']"))($rootScope);
		$rootScope.$apply();
	});
}