var ZBulkController = window.zkbangular.module("src", []);
ZBulkController.$inject = ["dataService","$scope"];
ZBulkController.controller('ZBulkController', function (dataService,$scope) {
	var zd = this;
	zd.init=function(){
        zd.DAYS_REMAINING_TO_WARN = 30;

		zd.maxEntries = 10;
		zd.disabledPublish = true;
		zd.disabledCancel = true;
		zd.disabledContinue = false;
		
		zd.showPublish = true;
		zd.showCancel = true;
		zd.showContinue = false;
		
		zd.showLoader = true;
		zd.resultHeader = false;
		zd.wrongSpace = false;
		zd.showProgress = false;
		zd.summaryResults = false;
		zd.generalError = false;
		zd.data = {};
		
		zd.progressTimeout = null;
		
		zd.draftNewOptions = [
			{id:'ND',label:'Publish as draft'},
			{id:'NP',label:'Publish as public'}
		];
		zd.draftNew = zd.draftNewOptions[0];
		
		zd.draftExistentOptions = [
			{id:'ED',label:'Update as draft'},
			{id:'EP',label:'Update as public'}
		];
		zd.draftExistent = zd.draftExistentOptions[0];
	};

	zd.initLicense = function(){
		zd.isLicensed = false;
	}

	zd.target = function(){
		return globalTarget;
    };

	zd.targetLabel =function(){
		return globalTarget.substring(0,1)	+globalTarget.substring(1).toLowerCase();
	};
	zd.writeGeneralError=function(response){
		zd.generalError = true;
		zd.showLoader = false;
		zd.showProgress = false;
		zd.summaryResults = false;
		zd.resultHeader = false;

		if(response.data && response.data.message){
			zd.generalErrorMessage = response.data.message;
		}else if(response.statusText){
            zd.generalErrorMessage =  response.statusText;
        }else{
            zd.generalErrorMessage = 'Unknown Error';
        }
	};
	zd.start = function(){
		zd.disabledPublish = true;
		zd.disabledCancel = true;			
		zd.showLoader = true;
		dataService.validate(globalTarget).then(function(result){
			window.console.log('validate',result);
			zd.monitorValidation(result.monitoringId);
		}).catch(function(response){
			zd.resultHeader = false;
			window.console.log('validate error',response);
			zd.writeGeneralError(response);
		}).finally(function(){
		});
	};
	zd.monitorValidation = function(monitoringId){
		dataService.monitorValidation(monitoringId).then(function(result){
			window.console.log('monitorValidation',result);
			if(result.status!=null){
				setTimeout(
						function(){
							zd.monitorValidation(monitoringId);
						},3000
				);
			}else{
				dataService.validationSummary().then(function(result){
					window.console.log('validationSummary',result);
					zd.resultHeader = false;
					zd.summaryResults = true;
					zd.validationSummary = result;
					var totalPages = result.pagesToPublish.length + result.pagesToUpdate.length;
					if(totalPages>0){
						zd.disabledContinue = false;
					}else{
						zd.disabledContinue = true;
					}
					zd.pagesInSummary = [
						{
							result: result.pagesToPublish,
							title : "Pages to be Published",
							style : "aui-icon aui-icon-small aui-iconfont-arrows-down",
							open : false
						},
						{
							result: result.pagesToUpdate,
							title : "Pages to be Updated",
							style : "aui-icon aui-icon-small aui-iconfont-arrows-down",
							open : false
						},
						{
							result: result.pagesToBeIgnored,
							title : "Pages to be Ignored (not yet assigned Categories, Channels and Record Type)",
							style : "aui-icon aui-icon-small aui-iconfont-arrows-down",
							open : false
						}
					];
				}).catch(function(response){
					window.console.log('validationSummary error',response);
					zd.writeGeneralError(response);
				}).finally(function(){
					zd.showPublish = false;
					zd.showCancel = false;
					zd.showContinue = true;
					zd.showLoader = false;
				});
			}
		}).catch(function(response){
			window.console.log('monitorValidation error',response);
			zd.writeGeneralError(response);
		}).finally(function(){
		});
	};
	zd.toogleResult = function(pageSet){
		if(pageSet.open){
			pageSet.open=false;
			pageSet.style="aui-icon aui-icon-small aui-iconfont-arrows-down";
		}else{
			pageSet.open=true;
			pageSet.style="aui-icon aui-icon-small aui-iconfont-arrows-up";
		}
	};
	zd.startInternal = function(){
		AJS.progressBars.update("#progress", 0);
			
		zd.showPublish = true;
		zd.showCancel = true;
		zd.showContinue = false;
		zd.showLoader = true;
		
		zd.disabledPublish = false;
		zd.disabledCancel = true;
		zd.disabledContinue = true;
		dataService.start(zd.draftNew.id,zd.draftExistent.id,zd.bulkNotAllowConfluenceLinks,zd.bulkNotAllowUnsupportedMacros,globalTarget).then(function(result){
			window.console.log('start internal',result);			
			zd.getProgress(true);
		}).catch(function(response){
			window.console.log('start internal error',response);
			zd.summaryResults = false;
			zd.showLoader = false;
			zd.writeGeneralError(response);			
		}).finally(function(){			
		});
	};
	zd.validateLicense = function(){
        dataService.isSfdcLicensed().then(function(isSfdcLicensed) {
            window.console.log('isSfdcLicensed',isSfdcLicensed);

            if(isSfdcLicensed.daysToExpire && isSfdcLicensed.daysToExpire!=-1  && isSfdcLicensed.daysToExpire<=zd.DAYS_REMAINING_TO_WARN){
                AJS.flag({
                    type: 'warning',
                    body: 'Your Knowledge:Bridge license will expire in '+isSfdcLicensed.daysToExpire+' days.',
                });
            }

			zd.isLicensed = true;
			zd.getProgress(true);

        }).catch(function(response) {
            window.console.log('isSfdcLicensed error',response);
            zd.writeGeneralError(response);
        });

	};
	zd.getProgress = function(ifProgressMonitor){
		dataService.getProgress(globalTarget).then(function(result){
			window.console.log('getProgress',result);
			zd.data = result;
			if(result.inProgress){
				zd.disabledPublish = true;
				if(result.spaceKey!=null && result.spaceKey!= AJS.params.spaceKey){
					zd.wrongSpace = true;
					zd.showLoader = false;
					zd.summaryResults = false;
				}else{					
					zd.summaryResults = false;					
					zd.showProgress = true;
					zd.disabledCancel = false;
					
					var progress = 0;
					if(zd.data.totalPages!=0){
						progress =(zd.data.totalError + zd.data.totalSuccess)/ zd.data.totalPages;
						window.console.log("progress",progress);
						AJS.progressBars.update("#progress", progress);
					}					
				}
			}else{
				zd.summaryResults = false;
				zd.showProgress = false;
				zd.showLoader = false;
				
				zd.disabledPublish = false;
				zd.disabledCancel = true;
				
				if(zd.data.totalPages>0 && zd.data.spaceKey== AJS.params.spaceKey){
					zd.resultHeader = true;
					zd.classResultHeader = "aui-message";
					if(zd.data.totalError>0 || zd.data.cancelled){
						zd.classResultHeader+=" error";
					}
				}
			}
			if(ifProgressMonitor && result.inProgress && result.spaceKey== AJS.params.spaceKey){
				zd.progressTimeout = setTimeout(
						function(){
							zd.getProgress(ifProgressMonitor);
						},2000
				);
			}
		}).catch(function(response){
			window.console.log('getProgress error:',response);
			zd.writeGeneralError(response);
		}).finally(function(){
			
		});
	};
	zd.formatDate=function(longDate){
		var date = new Date(longDate);
		return date.toLocaleString();
	};
	zd.parseAction=function(action){
		if(action=="UPDATE"){
			return "Updated";
		}
		if(action=="PUBLISH"){
			return "Published";
		}
	};
	zd.previous=function(){
		zd.init();
		zd.getProgress(true);
	};
	zd.cancel=function(){
		var confirmation = 
			confirm("The bulk process will stop and pages could remain unpublished, are you sure?");
		if(confirmation){
			dataService.cancel().then(function(result){
				window.console.log('cancel',result);
			}).catch(function(response){
				window.console.log('cancel error',response);
				zd.writeGeneralError(response);
			}).finally(function(){
			});
		}
	};
	zd.init();
	zd.initLicense();
	zd.validateLicense();
});

ZBulkController.factory("dataService",dataService);
dataService.$inject = ["$q","$http"];
function dataService($q,$http) {
	return {
			getProgress: function(target) {
				var deferred = $q.defer();
				var req = {
						method: "GET",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/get-progress/"+target,
						headers: {
							'Content-Type': "application/json"
						}
				};
				$http(req).then(function success(response) {
					deferred.resolve(response.data);
				}, function error(data) {
					deferred.reject(data);
				});
				return deferred.promise; 
			},
			start: function(draftNewOption,draftExistentOption,bulkNotAllowConfluenceLinks,bulkNotAllowUnsupportedMacros,target) {
				var deferred = $q.defer();
				var req = {
						method: "PUT",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/start/"+target+"?spaceKey="+
							AJS.params.spaceKey+"&draftNewOption="+draftNewOption+"&draftExistentOption="+draftExistentOption+
							'&bulkNotAllowConfluenceLinks='+bulkNotAllowConfluenceLinks+'&bulkNotAllowUnsupportedMacros='+bulkNotAllowUnsupportedMacros,
						headers: {
							'Content-Type': "application/json"
						}
				};
				$http(req).then(function success(response) {
					deferred.resolve(response.data);
				}, function error(data) {
					deferred.reject(data);
				});
				return deferred.promise; 
			},
			cancel: function() {
				var deferred = $q.defer();
				var req = {
						method: "PUT",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/cancel",
						headers: {
							'Content-Type': "application/json"
						}
				};
				$http(req).then(function success(response) {
					deferred.resolve(response.data);
				}, function error(data) {
					deferred.reject(data);
				});
				return deferred.promise; 
			},
			validate: function(target) {
				var deferred = $q.defer();
				var req = {
						method: "PUT",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/validate/"+target+"?spaceKey="+
							AJS.params.spaceKey,
						headers: {
							'Content-Type': "application/json"
						}
				};
				$http(req).then(function success(response) {
					deferred.resolve(response.data);
				}, function error(data) {
					deferred.reject(data);
				});
				return deferred.promise; 
			},
			monitorValidation: function(monitoringId) {
				var deferred = $q.defer();
				var req = {
						method: "GET",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/status/"+monitoringId,
						headers: {
							'Content-Type': "application/json"
						}
				};
				$http(req).then(function success(response) {
					deferred.resolve(response.data);
				}, function error(data) {
					deferred.reject(data);
				});
				return deferred.promise; 
			},
			validationSummary: function() {
				var deferred = $q.defer();
				var req = {
						method: "GET",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/bulk/summary?spaceKey="+
							AJS.params.spaceKey,
						headers: {
							'Content-Type': "application/json"
						}
				};
				$http(req).then(function success(response) {
					deferred.resolve(response.data);
				}, function error(data) {
					deferred.reject(data);
				});
				return deferred.promise; 
			},
        	isSfdcLicensed:function(){
				var deferred = $q.defer();
				var req = {
					method: "GET",
					url: AJS.contextPath()+"/rest/kb-internal/1.0/sfdc-utils/isSfdcLicensed",
					headers: {
						'Content-Type': "application/json"
					}
				};
				$http(req).then(function success(response) {
					deferred.resolve(response.data);
				}, function error(data) {
					deferred.reject(data);
				});
				return deferred.promise;
			}
	};   
}
AJS.$(document).ready(function() {
	AJS.$("div[ng-app='src']").css('display','block');           
}); 