var zendeskAuthController = window.zkbangular.module("src", []);
zendeskAuthController.$inject = ["dataService","$scope"];
zendeskAuthController.controller('ZendeskAuthController', function (dataService,$scope) {
	var zd = this;
	zd.isShowing = {};
	zd.isShowing.main = false;
	zd.isShowing.loader=true;
	
	zd.data = {};
	zd.data.error = false;
	zd.data.connected = false;
	zd.data.httpCode = 0;
	
	zd.loginButtonEnabled = true;
	
	
	
	zd.showStepOne = true;
	zd.showStepTwo = false;
	zd.showStepThree = false;
	zd.showStepFour = false;
	
	zd.showBackButton = false;
	zd.disableNextButton = false;
	zd.showWaitIcon = false;
	
	zd.NextButtonName = "Next";
	
	zd.nextStepId = 2;
	zd.backStepId = 1;
		
	dataService.getCredentials().then(function(result){
		window.console.log('result',result);
		zd.isShowing.main = true;
		zd.data = result;
	}).catch(function(response){
		window.console.log('get error:',response);
		zd.data.error = true;

		if(response.data && response.data.message){
			zd.data.errorMessage = response.data.message;
		}else if(response.statusText){
            zd.data.errorMessage =  response.statusText;
        }else{
            zd.data.errorMessage  = 'Unknown Error';
        }
	}).finally(function(){
		zd.isShowing.loader=false;
	});
	
	//--------------------------------------------------
	
	zd.nextStep = function(step) {
        if (step == 2) {        	
        	zd.data.url = zd.data.url.replace(/\/+$/,""); // clean all slash at end of URL
        	var url = zd.data.url.toLowerCase();
        	if(url == "" || url == "https://" || !url.startsWith("https://") || !url.endsWith(".zendesk.com")){
        		zd.url_error = "Please enter a valid Zendesk URL";
    		}
            else{
            	zd.disableNextButton = true;
            	zd.showWaitIcon = true;
            	dataService.pingURL(zd.data.url).then(function(result) {
	    			if(result.isValid){
	                	zd.url_error = null;
	                	zd.NextButtonName = "Save & Next";
	                	zd.nextStepId = 3;
	                	zd.backStepId = 1;
	                	zd.showStepOne = false;
	                	zd.showStepTwo = true;
	                	zd.showBackButton = true;
	    			}
	    			else{
	    				zd.url_error = "Please enter a valid Zendesk URL";
	    			}
	    	    }).catch(function(response) {
	            }).finally(function() {
	            	zd.disableNextButton = false;
	            	zd.showWaitIcon = false;
	            });
            }
        } else if (step == 3) {
        	var isOk = true;
       		if(zd.data.user==""){
    			zd.user_error = "You must specify a Zendesk User";
    			isOk = false;
    		}
        	else{
        		zd.user_error = null;
        		isOk = isOk && true;
        	}
        	if(zd.data.apiToken==""){
    			zd.token_error = "You must specify a Zendesk API Token";
    			isOk = false;
    		}
        	else{
        		zd.token_error = null;
        		isOk = isOk && true;
        	}
        	if(isOk){
            	zd.disableNextButton = true;
            	zd.showWaitIcon = true;
            	
        		var bean = {
    					url: zd.data.url,
    					user: zd.data.user,
    					apiToken: zd.data.apiToken,
    			};
    			zd.loginButtonEnabled = false;
    			dataService.loginAndSave(bean).then(function(result){
    				window.console.log('result',result);
    				zd.isShowing.main = true;
    				zd.data = result;
    				
    				if(!result.error){
    					zd.nextStepId = 4;
    					zd.backStepId = 2;
    				
    					zd.showStepOne = false;
    					zd.showStepTwo = false;
    					zd.showStepThree = true;
    				
    					zd.NextButtonName = "Done";
    				}
    				
    			}).catch(function(response){
    				window.console.log('login error:',response);
    				zd.data.error = true;

    				if(response.data && response.data.message){
    					zd.data.errorMessage = response.data.message;
    				}else if(response.statusText){
                        zd.data.errorMessage =  response.statusText;
                    }else{
                        zd.data.errorMessage  = 'Unknown Error';
                    }
    			}).finally(function(){
    				zd.loginButtonEnabled = true;
    				
                	zd.disableNextButton = false;
                	zd.showWaitIcon = false;
    			});
        	}
        } else if (step == 4){
            window.location = AJS.contextPath() + "/admin/knowledge-bridge/zendeskauth.action";
        }
    }
	
	zd.backStep = function(step) {
        if (step == 1) {        	
        	zd.showStepOne = true;
			zd.showStepTwo = false;
        	
            zd.showBackButton = false;
            zd.NextButtonName = "Next";
            zd.nextStepId = 2;
        } else if (step == 2) {
        	zd.showStepTwo = true;
        	zd.showStepThree = false;
        	
        	zd.showBackButton = true;
        	zd.url_error = null;
        	zd.nextStepId = 3;
        	zd.backStepId = 1;
        	zd.NextButtonName = "Save & Next";
        } 
    }
	
	zd.login = function(){
		zd.data.error = false;
		zd.data.httpCode = 0;
		zd.data.connected = false;
		zd.data.errorMessage = "";
		
		zd.token_error = "";
		zd.user_error = "";
		zd.url_error="";
		
		var isOk = true;
		if(zd.data.apiToken==""){
			zd.token_error = "You must specify a Zendesk API Token";
			isOk = false;
		}
		if(zd.data.user==""){
			zd.user_error = "You must specify a Zendesk User";
			isOk = false;
		}
		if(zd.data.url==""||zd.data.url=="https://"){
			zd.url_error="Please enter a valid Zendesk URL";
			isOk = false;
		}
		
		if(isOk){
			var bean = {
					url: zd.data.url,
					user: zd.data.user,
					apiToken: zd.data.apiToken,
			};
			zd.loginButtonEnabled = false;
			dataService.loginAndSave(bean).then(function(result){
				window.console.log('result',result);
				zd.isShowing.main = true;
				zd.data = result;
			}).catch(function(response){
				window.console.log('login error:',response);
				zd.data.error = true;

				if(response.data && response.data.message){
					zd.data.errorMessage = response.data.message;
				}else if(response.statusText){
                    zd.data.errorMessage =  response.statusText;
                }else{
                    zd.data.errorMessage  = 'Unknown Error';
                }
			}).finally(function(){
				zd.loginButtonEnabled = true;
			});
		}
	};
	
	zd.confluenceSpaces = function() {
		dataService.confluenceSpaces().then(function(result) {
            zd.spaces = result['spaces'];
        }).catch(function(response) {
            zd.error = true;

            if(response.data && response.data.message){
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage  = 'Unknown Error';
            }
        }).finally(function() {
        });
    }
	
	zd.shouldEnabledSpaceSelect = function() {
		if(zd.createBlankSpace){
			zd.selectedSpace = null;
			zd.nextStepId = "2-2";
		}
		else{
			zd.nextStepId = "3-1";
		}
    	zd.backStepId = "2-1";
	},
	zd.createSpace = function() {
		dataService.createSpace().then(function(result) {
            
        }).catch(function(response) {
            zd.error = true;
            if(response.data && response.data.message){
                zd.errorMessage = response.data.message;
            }else if(response.statusText){
                zd.errorMessage =  response.statusText;
            }else{
                zd.errorMessage  = 'Unknown Error';
            }
        }).finally(function() {
        });
	}
});

zendeskAuthController.factory("dataService",dataService);
dataService.$inject = ["$q","$http"];
function dataService($q,$http) {
	var service = {
			loginAndSave: function(bean) {
				var deferred = $q.defer();
	
				var req = {
						method: "PUT",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/auth/login/ZENDESK",
						headers: {
							'Content-Type': "application/json"
						},
						data: bean
				};
				$http(req).then(function success(response) {
                    deferred.resolve(response.data);
			    }, function error(data) {
			    	deferred.reject(data);
			    });
				return deferred.promise;
			},
			getCredentials: function() {
				var deferred = $q.defer();
				var req = {
						method: "GET",
						url: AJS.contextPath()+"/rest/kb-internal/1.0/auth/get-credentials/ZENDESK",
						headers: {
							'Content-Type': "application/json"
						}
				};
				$http(req).then(function success(response) {
                    deferred.resolve(response.data);
			    }, function error(data) {
			    	deferred.reject(data);
			    });
				return deferred.promise; 
			},
			confluenceSpaces: function() {
	            var deferred = $q.defer();
	            var req = {
	                method: "GET",
	                url: AJS.contextPath() + "/rest/kb-internal/1.0/auth/confluence-spaces",
	                headers: {
	                    'Content-Type': "application/json"
	                },
	            };
	            $http(req).then(function success(response) {
	                deferred.resolve(response.data);
	            }, function error(data) {
	                deferred.reject(data);
	            });
	            return deferred.promise;
	        },
			pingURL: function(URL) {
	            var deferred = $q.defer();
	            var req = {
	                method: "GET",
	                url: AJS.contextPath() + "/rest/kb-internal/1.0/auth/check-url?url=" + URL,
	            };
	            $http(req).then(function success(response) {            	
	                deferred.resolve(response.data);
	            }, function error(data) {
	                deferred.reject(data);
	            });
	            return deferred.promise;
	        }
	        ,
			createSpace: function(name,key) {
	            var deferred = $q.defer();
	            var req = {
	                method: "POST",
	                url: AJS.contextPath() + "/rest/kb-internal/1.0/auth/create-space?name=" + name + "&key=" + key,
	                headers: {
	                    'Content-Type': "application/json"
	                },
	                data : null
	            };
	            $http(req).then(function success(response) {            	
	                deferred.resolve(response.data);
	            }, function error(data) {
	                deferred.reject(data);
	            });
	            return deferred.promise;
	        }
	};        
	return service;                
}  