var ZWizardController = zAppMapper;
ZWizardController.$inject = ["dataService", "$scope", "cTreeRemoteService", "cMapperRemoteService"];
ZWizardController.controller('ZWizardController', function(dataService, $scope, cTreeRemoteService, cMapperRemoteService) {
    var zkb = this;
    zkb.isEnabled = false;
    zkb.publishLabels = false;
    zkb.selectedGroups = [];
    zkb.selectedBehavior = '';
    zkb.selectedFormatArticleURLName = 'Key';
    zkb.selectedArticleStylingMode = 'BY_CSS_INLINE';

    zkb.showStepOne = true;
    zkb.showStepTwo = false;
    zkb.showStepThree = false;
    zkb.showStepFour = false;

    zkb.enableNextStepTwoButton = false;
    zkb.enableNextStepThreeButton = false;
    zkb.enableNextStepFourButton = true;

    zkb.showDescendantsTree = false;
    zkb.showWaitIcon = false;
    zkb.showImportMessage = false;

    zkb.emptyGroupList = false;

    zkb.showFreeForm = false;
    zkb.showDescendants = false;
    zkb.showByLabels = false;

    zkb.info = false;
    zkb.error = false;
    zkb.errorMessage = '';
    zkb.showDetails = false;

    zkb.importResult;

    zkb.showCreated = false;
    zkb.showIgnored = false;
    zkb.showFailed = false;

    zkb.showBackButton = false;
    zkb.showImportButton = false;
    zkb.showDoneButton = false;
    zkb.showSkipButton = false;
    zkb.target = function(){
        return globalTarget;
    };

    zkb.getTargetLabel = function(targetName) {
        return targetName.substring(0,1)+targetName.substring(1).toLowerCase();
    };

    zkb.nextStep = function(step) {
        if (step === 2) {
            zkb.showStepOne = false;
            zkb.showStepTwo = true;
        }
        else if ( step === 3){
            zkb.showStepTwo = false;
            zkb.showStepThree = true;
        }
        else if (step === 4) {
            zkb.showStepThree = false;
            zkb.showStepFour = true;
            if (zkb.selectedBehavior == 'free' ) {
                zkb.showBackButton = true;
                zkb.showImportButton = false;
                zkb.showDoneButton = true;
                zkb.showSkipButton = false;

                cTreeRemoteService.reRender(zkb.selectedBehavior);
            } else if (zkb.selectedBehavior == 'descendants') {
                if(globalTarget == 'SALESFORCE'){
                    zkb.showBackButton = true;
                    zkb.showImportButton = false;
                    zkb.showDoneButton = true;
                    zkb.showSkipButton = false;

                    zkb.showDescendantsTree = true;

                    cTreeRemoteService.reRender(zkb.selectedBehavior);
                }else{
                    zkb.sectionsCount();
                }
            } else if (zkb.selectedBehavior == 'labels') {
                zkb.showBackButton = true;
                zkb.showImportButton = false;
                zkb.showDoneButton = true;
                zkb.showSkipButton = false;
            }
        }
    }

    zkb.backStep = function(step) {
        if (step === 3) {
            zkb.showStepTwo = false;
            zkb.showStepThree = true;
            zkb.showStepFour = false;
            zkb.showDescendantsTree = false;

            zkb.showBackButton = false;
            zkb.showImportButton = false;
            zkb.showDoneButton = false;
            zkb.showSkipButton = false;

            zkb.showImportMessage = false;

            zkb.error = false;
            zkb.info = false;
        }
        else if(step === 2){
            zkb.showStepTwo = true;
            zkb.showStepThree = false;
        }
        else if (step === 1) {
            zkb.showStepOne = true;
            zkb.showStepTwo = false;
        }
    }

    zkb.shouldEnableNextButton = function(step) {
        if (step == 1) {
            zkb.enableNextStepTwoButton = zkb.isEnabled && (zkb.selectedGroups.length > 0);
        } else if (step == 2) {
            zkb.enableNextStepThreeButton = zkb.selectedBehavior != '';
        } else if (step === 3){
            zkb.enableNextStepFourButton = true;
        }
    }

    zkb.modeLabel=function(){
        if(zkb.showFreeForm){
            return "Free-Form";
        }
        if(zkb.showDescendants){
            return "Hierarchical";
        }
        return zkb.mode;
    }

    zkb.updateBehavior = function(behavior) {
        zkb.mode = behavior;
        zkb.selectedBehavior = behavior;
        if (behavior == 'free') {
            zkb.showFreeForm = true;
            zkb.showDescendants = false;
            zkb.showByLabels = false;
        } else if (behavior == 'descendants') {
            zkb.showFreeForm = false;
            zkb.showDescendants = true;
            zkb.showByLabels = false;

            zkb.showBackButton = false;
            zkb.showImportButton = false;
            zkb.showDoneButton = false;
            zkb.showSkipButton = false;
        } else if (behavior == 'labels') {
            zkb.showFreeForm = false;
            zkb.showDescendants = false;
            zkb.showByLabels = true;
        }

        zkb.shouldEnableNextButton(2);
    }

    zkb.updateFormatArticleURLName = function( formatArticleURLName ){
        zkb.selectedFormatArticleURLName = formatArticleURLName;
    };

    zkb.updateArticleStylingMode = function( articleStylingMode ){
        zkb.selectedArticleStylingMode = articleStylingMode;
    };

    zkb.done = function() {

        if (zkb.selectedBehavior === 'labels') {
            cMapperRemoteService.remoteSaveMap().then(function(result) {

                zkb.internalDone();

            }).catch(function(response) {
                zkb.error = true;
                zkb.errorMessage = 'It was not possible to save Label Mapping.';
            }).finally(function() {});
        } else {
            zkb.internalDone();
        }

    };

    zkb.internalDone = function() {
        var body = {
            "enabled": zkb.isEnabled,
            "groups": zkb.selectedGroups,
            "publishLabels": zkb.publishLabels,
            "behavior": zkb.selectedBehavior,
            "formatArticleURLName": zkb.selectedFormatArticleURLName,
            "articleStylingMode": zkb.selectedArticleStylingMode
        };
        dataService.saveConfig(body).then(function(result) {
            window.location = AJS.contextPath() + '/spaces/knowledge-bridge/spacesettings.action?key=' + AJS.params.spaceKey;
        }).catch(function(response) {
            zkb.error = true;
            if (response.data && response.data.message) {
                zkb.errorMessage  = response.data.message;
            }else if(response.statusText){
                zkb.errorMessage =  response.statusText;
            }else{
                zkb.errorMessage  = 'Unknown Error';
            }
        }).finally(function() {});
    }

    zkb.sectionsCount = function() {
        zkb.showWaitIcon = true;
        dataService.sectionsCount().then(function(result) {
            zkb.showWaitIcon = false;
            if (result['sectionsCount'] > 0) {

                zkb.showImportMessage = true;

                zkb.showBackButton = true;
                zkb.showImportButton = true;
                zkb.showDoneButton = false;
                zkb.showSkipButton = true;
            } else {
                zkb.showBackButton = true;
                zkb.showImportButton = false;
                zkb.showDoneButton = true;
                zkb.showSkipButton = false;

                zkb.showDescendantsTree = true;

                cTreeRemoteService.reRender(zkb.selectedBehavior);
            }
        }).catch(function(response) {
            zkb.error = true;

            if (response.data && response.data.message) {
                zkb.errorMessage = response.data.message;
            }else if(response.statusText){
                zkb.errorMessage =  response.statusText;
            }else{
                zkb.errorMessage  = 'Unknown Error';
            }
            zkb.showWaitIcon = false;
            zkb.showImportMessage = false;

            zkb.showBackButton = true;
            zkb.showImportButton = false;
            zkb.showDoneButton = true;
            zkb.showSkipButton = false;
        }).finally(function() {});
    }

    zkb.import = function() {
        zkb.showImportMessage = false;
        zkb.showWaitIcon = true;

        zkb.showBackButton = false;
        zkb.showImportButton = false;
        zkb.showDoneButton = false;
        zkb.showSkipButton = false;

        dataService.import().then(function(result) {
            zkb.showWaitIcon = false;
            zkb.showDescendantsTree = true;
            zkb.info = true;
            zkb.importResult = result;

            if (zkb.importResult.created > 0) {
                zkb.showCreated = true;
            }

            if (zkb.importResult.ignored > 0) {
                zkb.showIgnored = true;
            }

            if (zkb.importResult.failed > 0) {
                zkb.showFailed = true;
            }

            zkb.showBackButton = true;
            zkb.showImportButton = false;
            zkb.showDoneButton = true;
            zkb.showSkipButton = false;

            cTreeRemoteService.reRender(zkb.selectedBehavior);
        }).catch(function(response) {
            zkb.showWaitIcon = false;
            zkb.error = true;

            if (response.data && response.data.message) {
                zkb.errorMessage = response.data.message;
            }else if(response.statusText){
                zkb.errorMessage =  response.statusText;
            }else{
                zkb.errorMessage  = 'Unknown Error';
            }

            zkb.showBackButton = true;
            zkb.showImportButton = false;
            zkb.showDoneButton = true;
            zkb.showSkipButton = false;

            cTreeRemoteService.reRender(zkb.selectedBehavior);
        }).finally(function() {});
    }

    zkb.skip = function() {
        zkb.showImportMessage = false;
        zkb.showDescendantsTree = true;

        zkb.showImportButton = false;
        zkb.showSkipButton = false;
        zkb.showDoneButton = true;

        cTreeRemoteService.reRender(zkb.selectedBehavior);
    }

    zkb.details = function() {
        zkb.showDetails = !zkb.showDetails;
    }
});

ZWizardController.factory("dataService", dataService);
dataService.$inject = ["$q", "$http"];

function dataService($q, $http) {
    return {
        saveConfig: function(body) {
            var deferred = $q.defer();
            var req = {
                method: "POST",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/wizard/save-config/" + AJS.params.spaceKey,
                headers: {
                    'Content-Type': "application/json"
                },
                data: body
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        sectionsCount: function() {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/wizard/sections-count",
                headers: {
                    'Content-Type': "application/json"
                },
                data: null
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        import: function() {
            var deferred = $q.defer();
            var req = {
                method: "POST",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/wizard/import/" + AJS.params.spaceKey,
                headers: {
                    'Content-Type': "application/json"
                },
                data: null
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        confluenceLabels: function() {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/wizard/confluence-labels",
                headers: {
                    'Content-Type': "application/json"
                },
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getSections: function(categoryId) {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/zendesk-utils/sections/" + categoryId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        getCategories: function() {
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/zendesk-utils/categories",
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        },
        setLabels: function(body) {
            var deferred = $q.defer();
            var req = {
                method: "POST",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/wizard/labels",
                headers: {
                    'Content-Type': "application/json"
                },
                data: body
            };
            $http(req).then(function success(response) {
                deferred.resolve(response.data);
            }, function error(data) {
                deferred.reject(data);
            });
            return deferred.promise;
        }
    };
}