var KFController=function($rootScope, $scope, $element, KFService, KCSService) {
    var kf = this;
    $rootScope['KFController'] = kf;
    $rootScope['element'] = $element;

    kf.availableChannels = [{ id: 'IsVisibleInApp', text: 'Internal App'},{ id: 'IsVisibleInPrm', text: 'Partner'},{ id: 'IsVisibleInCsp', text: 'Customer'},{ id: 'IsVisibleInPkb', text: 'Public Knowledge Base'}];
    kf.defaultChannel = [{ id: 'IsVisibleInApp', text: 'Internal App', locked: true}];

    kf.channelsMap = {};
    kf.availableChannels.forEach(function(channel){
        kf.channelsMap[channel.id]=channel.text;
    });
};

var KFService = function($rootScope, $q, $http) {
    return {
        channelLabel:function(id){
            kf = $rootScope['KFController'];
            return kf.channelsMap[id];
        },
        setMetadata: function(metadata){
            kf = $rootScope['KFController'];
            kf.selectedRecordType = null;
            element = $rootScope['element'];
            kf.metadata = metadata;

            var availableChannels = kf.availableChannels;
            var defaultChannel = kf.defaultChannel;

            AJS.$("#urlName").tooltip({aria:true});
            element.find("#channels-select").auiSelect2({
                multiple: true,
                query: function (query){
                    var data = {results: availableChannels};
                    query.callback(data);
                }
            });

            element.find("#channels-select").auiSelect2('data', defaultChannel);
        },
        setData:function(data){
            kf = $rootScope['KFController'];
            element = $rootScope['element'];

            if(data.channels){
                var channels = [];
                channels.push(kf.defaultChannel[0]);

                for(var i =0;i<data.channels.length;i++){
                    var channel =data.channels[i];
                    if(channel!='IsVisibleInApp'){
                        for(var j=0;j<kf.availableChannels.length;j++){
                            var availableChannel = kf.availableChannels[j];
                            if(availableChannel.id == channel){
                                channels.push(availableChannel);
                            }
                        }
                    }
                }
                element.find("#channels-select").auiSelect2('data', channels);
            }
            if(data.recordType){
                for(var i =0;i<kf.metadata.recordTypes.length;i++){
                    if(kf.metadata.recordTypes[i].id==data.recordType.id){
                        kf.selectedRecordType = kf.metadata.recordTypes[i];
                        break;
                    }
                }
            }
        },
        selectedRecordType:function(){
            kf = $rootScope['KFController'];
            return kf.selectedRecordType != null ? kf.selectedRecordType : null;
        },
        recordTypeError:function(value){
            kf = $rootScope['KFController'];
            kf.recordTypeError = value;
        },
        selectedChannels:function(){
            element = $rootScope['element'];
            var selectedChannels = element.find("#channels-select").val().split(",");
            return selectedChannels == null ? [] : selectedChannels;
        },
        disabledRecordType:function(value){
            kf = $rootScope['KFController'];
            kf.disabledRecordType = value;
        }
    };
};


function loadKnowledgeFieldsComponent(app) {
    var zApp = app;

    zApp.factory("KFService", KFService);
    KCSService.$inject = ["$rootScope", "$q", "$http"];

    zApp.component("kfselector", {
        bindings: {
            pageId: '@'
        },
        templateUrl: AJS.Data.get("context-path") +
            '/download/resources/com.zagile.confluence.kb.knowledge-bridge:knowledge-fields-selector/knowledge-fields-selector.html',
        controller: ['$rootScope', '$scope', '$element', '$q', 'KFService', KFController]
    });
}