// Reference to the controller of the details about SF data
// It will in charge of raise/hide/show salesforceFeedbackDetailsPopup
var salesforceFeedbackControllerInstance;

AJS.toInit(function() {

    if (!document.getElementById('retrieveSalesforceFeedback') &&
        !document.getElementById('salesforce-article-info')
    ) {
        return;
    }

    window.AJS.$("#retrieveSalesforceFeedback, #salesforce-article-info").click(function (e) {
        e.preventDefault();
        if (window.AJS.$("#sf-more-details").length === 0) {
            initializeSalesforceFeedbackDetails();
        } else {
            salesforceFeedbackControllerInstance.openAndGetSalesforceFeedback();
        }
    });
});

var salesforceFeedbackController = function($scope, salesforceFeedbackService) {

    $scope.placeholder = 'placeholder' + new Date();

    salesforceFeedbackControllerInstance = this;

    this.openAndGetSalesforceFeedback = function () {
        window.AJS.dialog2("#sf-more-details").show();
        $scope.detailsController.getSalesforceFeedback();
    }

    this.$onInit = function () {
        window.AJS.dialog2("#sf-more-details").show();
    };
};

var salesforceFeedbackService = function($q, $http){
    return {
        promises:{
            PLACEHOLDER: null
        },
        cancel: function(){
            if( this.promises.PLACEHOLDER ){
                this.promises.PLACEHOLDER.resolve();
            }
        },
        PLACEHOLDER: function(){
            var deferred = $q.defer();
            var req = {
                method: "GET",
                url: AJS.contextPath() + "/rest/kb-internal/1.0/sfdc-utils/[PLACEHOLDER]/" + AJS.params.pageId,
                headers: {
                    'Content-Type': "application/json"
                }
            };
            $http(req).then(function success(response) {
                deferred.resolve( response.data );
            }, function error( data ) {
                deferred.reject( data );
            });
            this.promises.PLACEHOLDER = deferred;
            return deferred.promise;
        }
    }
};

function initializeSalesforceFeedbackDetails() {
    // inject dialog with angular component to body
    var dialog2Source = "";
    dialog2Source += "<section id='sf-more-details' class='aui-layer aui-dialog2 aui-dialog2-medium' role='dialog' aria-hidden='true'>";
    dialog2Source += "  <div ng-app='salesforceFeedbackApp' class='aui-dialog2-content'>";
    dialog2Source += "      <salesforce-feedback>";
    dialog2Source += "      </salesforce-feedback>";
    dialog2Source += "  </div>";
    dialog2Source += "  <footer class='aui-dialog2-footer'>";
    dialog2Source += "      <div class='aui-dialog2-footer-actions'>";
    dialog2Source += "          <button onclick='AJS.dialog2(\"#sf-more-details\").hide();' class='aui-button aui-button-primary'>Close</button>";
    dialog2Source += "      </div>";
    dialog2Source += "  </footer>";
    dialog2Source += "</section>";

    AJS.$(document.body).append(AJS.$(dialog2Source));

    // create angular app, initiate component and relate controller and services
    var salesforceFeedbackApp = window.zkbangular.module("salesforceFeedbackApp", []);
    salesforceFeedbackApp.factory("salesforceFeedbackService", salesforceFeedbackService);
    salesforceFeedbackService.$inject = ["$q", "$http"];

    loadKnowledgeSalesforceFeedbackDetailsComponent(salesforceFeedbackApp);

    salesforceFeedbackApp.component("salesforceFeedback", {
        templateUrl: AJS.Data.get("context-path") +
            '/download/resources/com.zagile.confluence.kb.knowledge-bridge:salesforce-feedback-resources/knowledge-sf-feedback.html',
        controller: ['$scope', 'salesforceFeedbackService', salesforceFeedbackController]
    });

    // compile angular app
    var injector = window.zkbangular.injector(["ng", "salesforceFeedbackApp"]);
    injector.invoke(function($compile, $rootScope) {
        $compile(AJS.$("div[ng-app='salesforceFeedbackApp']"))($rootScope);
        $rootScope.$apply();
    });
}

